Package: RcisTarget
Type: Package
Title: RcisTarget Identify transcription factor binding motifs enriched on a
    list of genes or genomic regions
Version: 1.22.0
Date: 2022-12-01
Author: Sara Aibar, Gert Hulselmans, Stein Aerts. Laboratory of Computational Biology. 
    VIB-KU Leuven Center for Brain & Disease Research. Leuven, Belgium
Maintainer: Sara Aibar <sara.aibar@kuleuven.vib.be>
Description: RcisTarget identifies transcription factor binding
    motifs (TFBS) over-represented on a gene list.
    In a first step, RcisTarget selects DNA motifs that are significantly 
    over-represented in the surroundings of the transcription start site (TSS) 
    of the genes in the gene-set. 
    This is achieved by using a database that contains genome-wide cross-species 
    rankings for each motif. The motifs that are then annotated to TFs and those
    that have a high Normalized Enrichment Score (NES) are retained. 
    Finally, for each motif and gene-set, 
    RcisTarget predicts the candidate target genes 
    (i.e. genes in the gene-set that are ranked above the leading edge).
URL: http://scenic.aertslab.org
Depends: R (>= 3.4)
Imports:
    AUCell (>= 1.1.6),
    BiocGenerics,
    data.table,
    graphics,
    GenomeInfoDb,
    GenomicRanges,
    arrow (>= 2.0.0),
    dplyr,
    tibble,
    GSEABase,
    methods,
    R.utils,
    stats,
    SummarizedExperiment,
    S4Vectors,
    utils
Enhances: doMC, doRNG, zoo
Suggests:
    Biobase,
    BiocStyle,
    BiocParallel,
    doParallel,
    DT,
    foreach,
    gplots,
    rtracklayer,
    igraph,
    knitr,
    RcisTarget.hg19.motifDBs.cisbpOnly.500bp, 
    rmarkdown,
    testthat,
    visNetwork
License: GPL-3
BugReports: https://github.com/aertslab/RcisTarget/issues
biocViews: GeneRegulation, MotifAnnotation, Transcriptomics, Transcription,
    GeneSetEnrichment, GeneTarget
LazyData: FALSE
VignetteBuilder: knitr
RoxygenNote: 7.2.1

# RcisTarget
RcisTarget is an R-package to identify transcription factor (TF) binding motifs over-represented on a gene list. 

*Availability*: 

- The newest stable version of RcisTarget is available in *[Bioconductor](https://bioconductor.org/packages/RcisTarget)*. 
The package also contains a **tutorial** [(vignette)](https://bioconductor.org/packages/release/bioc/vignettes/RcisTarget/inst/doc/RcisTarget.html) with information on how to run RcisTarget and how to interprete its results.

- This Github repository is meant mostly for development. "Use at your own risk" :-). Developers are welcome to contribute. 

----


*Databases*: 

The databases required to run (R)cisTarget are available at https://resources.aertslab.org/cistarget/ (see the vignette for details). Alternative *mirror*: https://resources-mirror.aertslab.org/cistarget/.

A tutorial on how to **create databases** with different settings (e.g. **new species**) is available at https://github.com/aertslab/create_cisTarget_databases

.plotRCC <- function(rccMean, rccM2sd, srName, mErn, rcc)
{
  plot(rccMean, type="l", col="red", xlab="Rank", ylab="# genes recovered",
       ylim=c(0,(max(c(rccM2sd, rcc)))+1), lwd=1, main=srName)
  polygon(c(0,seq_along(rccM2sd),length(rccM2sd)), c(0,rccM2sd,0),
          col="#aa660040", border=FALSE)
  lines(rccM2sd, type="l", col="green", lwd=1)

  lines(rcc, col="blue")
  points(mErn["x"], mErn["y"], type="h", lty=2, col="blue")
  lines(c(mErn["x"], mErn["x"]), c(rccM2sd[mErn["x"]], mErn["y"]),
        lwd=2, col="blue")
  lines(c(0, mErn["x"]), c(mErn["y"], mErn["y"]), lty=2, col="darkgrey")
  points(mErn["x"], mErn["y"], type="b", pch=16, col="blue")
}

# Example for running RcisTarget using cisTarget() function (workflow wrapper)

\dontrun{

##################################################
### Load your gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

#### Load databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
motifRankings <- importRankings("~/databases/hg38_10kbp_up_10kbp_down_full_tx_v10_clust.genes_vs_motifs.rankings.feather")

## Motif - TF annotation:
data("motifAnnotations_hgnc") # human TFs (for motif collection 10)
##################################################

# Run (R)cisTarget
motifEnrichmentTable_wGenes <- cisTarget(geneLists, motifRankings,
  motifAnnot_direct=hg19_direct_motifAnnotation,
  nesThreshold=3.5, geneErnMethod="aprox", nCores=2)

}

# Load results from analysis
load(paste(file.path(system.file('examples', package='RcisTarget')),
           "motifEnrichmentTable_wGenes.RData", sep="/"))


### Exploring the output:
# Note: If using the fake-database, the results are not meaningful

# Number of enriched motifs (Over the given NES threshold)
nrow(motifEnrichmentTable_wGenes)

# Available info (columns)
colnames(motifEnrichmentTable_wGenes)

# The object returned is a data.table (for faster computation),
# which has a diferent syntax from the standard data.frame or matrix
# Feel free to convert it to a data.frame (as.data.frame())
class(motifEnrichmentTable_wGenes)
motifEnrichmentTable_wGenes[,1:5]

# Enriched genes
enrGenes <- as.character(motifEnrichmentTable_wGenes[1,"enrichedGenes"])
strsplit(enrGenes, ";")


# Interactive exploration
motifEnrichmentTable_wGenes <- addLogo(motifEnrichmentTable_wGenes)
DT::datatable(motifEnrichmentTable_wGenes[,1:9], escape = FALSE, filter="top",
              options=list(pageLength=5))
# Note: If using the fake database, the results of this analysis are meaningless

#' @title cisTarget
#' @rdname RcisTarget
#' @description Identifies DNA motifs significantly over-represented in a
#' gene-set.
#'
#' This is the main function to run RcisTarget.
#' It includes on the following steps:
#' \itemize{
#' \item 1. Motif enrichment analysis (\link{calcAUC})
#' \item 2. Motif-TF annotation (\link{addMotifAnnotation})
#' \item 3. Selection of significant genes (\link{addSignificantGenes})
#' }
#'
#' @param geneSets List of gene-sets to analyze.
#' The gene-sets should be provided as \code{\link{GeneSet}},
#' \code{\link{GeneSetCollection}} or character list (see examples).
#' @param motifRankings Database of the appropiate organism and search-space
#' (i.e. 10kbp around- or 500bp upstream the TSS).
#' These objects are provided in separate files, 
#' which can be imported with \code{importRankings()}:
#' \itemize{
#' \item \url{http://pyscenic.aertslab.org/databases/mm9-500bp-upstream-7species.mc9nr.feather}[mm9-500bp-upstream-7species.mc9nr] (Mouse, 500bp)
#' \item \url{http://pyscenic.aertslab.org/databases/mm9-tss-centered-10kb-7species.mc9nr.feather}[mm9-tss-centered-10kb-7species.mc9nr] (Mouse, 10kbp)
#' \item \url{http://pyscenic.aertslab.org/databases/hg19-500bp-upstream-7species.mc9nr.feather}[hg19-500bp-upstream-7species.mc9nr] (Human, 500bp)
#' \item \url{http://pyscenic.aertslab.org/databases/hg19-tss-centered-10kb-7species.mc9nr.feather}[hg19-tss-centered-10kb-7species.mc9nr] (Human, 10kbp)
#' \item -Coming soon- (Fly)
#' }
#' See \code{vignette("RcisTarget")} for an exhaustive list of databases.
#' @param motifAnnot Motif annotation database containing the
#' annotations of the motif to transcription factors.
#' @param motifAnnot_highConfCat Categories considered as source for 
#' 'high confidence' annotations. By default, 
#' "directAnnotation" (annotated in the source database), and 
#' "inferredBy_Orthology" (the motif is annotated to an homologous/ortologous 
#' gene).
#' @param motifAnnot_lowConfCat Categories considered 
#' 'lower confidence' source for annotations. By default, the annotations 
#' inferred based on motif similarity ("inferredBy_MotifSimilarity", 
#' "inferredBy_MotifSimilarity_n_Orthology").
#' @param highlightTFs Character. 
#' If a list of transcription factors is
#' provided, the column TFinDB in the otuput table will indicate whether any
#' of those TFs are included within the 'high-confidence' annotation 
#' (two asterisks, **)
#' or 'low-confidence' annotation (one asterisk, *) of the motif.
#' The vector can be named to indicate which TF to highlight for each gene-set.
#' Otherwise, all TFs will be used for all geneSets.
#' @param nesThreshold Numeric.
#' NES threshold to calculate the motif significant (3.0 by default).
#' The NES is calculated -for each motif- based on the AUC distribution of
#' all the motifs for the gene-set [(x-mean)/sd].
#' The motifs are considered significantly enriched if they pass the the
#'  Normalized Enrichment Score (NES) threshold.
#' @param aucMaxRank Threshold to calculate the AUC.
#' In a simplified way, the AUC value represents the fraction of genes -within
#'  the top X genes in the ranking- that are included in the signature.
#' The parameter 'aucThresholdPERC' allows to modify the percentage of genes
#' (of the top of the ranking) that is used to perform this computation.
#' By default it is set to 5\% of the total number of genes in the rankings.
#' Common values range from 1 to 10\%.
#' @param geneErnMethod "iCisTarget" or "aprox". Method to identify the highly
#' ranked genes (see \link{addSignificantGenes} for details).
#' @param geneErnMaxRank Maximum rank to take into account for the gene
#' enrichment recovery curve (see \link{addSignificantGenes} for details).
#' @param nCores Number of cores to use for computation.
#' Note: In general, using a higher number of cores (e.g. processes) decreases
#' overall running time. However, it also deppends on the available memory and
#' overall system load. Setting nCores too high might also decrease performance.
#' @param verbose Should the function show progress messages? (TRUE / FALSE)
#' @return \code{\link[data.table]{data.table}} containing the over-represented
#' motifs (according to the selected NES threshold),
#' their statistics, annotation to transcription factors and the genes with
#' high enrichment of the motif.
#' @seealso See the package vignette for examples and more details:
#' \code{vignette("RcisTarget")}
#' @example inst/examples/example_cisTarget.R
#' @export
cisTarget <- function(geneSets, motifRankings,
          motifAnnot=NULL,
          motifAnnot_highConfCat=c("directAnnotation", "inferredBy_Orthology"), 
          motifAnnot_lowConfCat=c("inferredBy_MotifSimilarity", 
                                  "inferredBy_MotifSimilarity_n_Orthology"), 
          highlightTFs=NULL, nesThreshold=3.0,
          aucMaxRank=0.05*ncol(motifRankings),
          geneErnMethod="aprox", geneErnMaxRank=5000,
          nCores=1, verbose=TRUE)
{
  # Calculate AUC
  motifs_AUC <- calcAUC(geneSets=geneSets,
                        rankings=motifRankings,
                        nCores=nCores,
                        aucMaxRank=aucMaxRank,
                        verbose=verbose)

  # Select significant motifs, add TF annotation & format as table
  motifEnrichmentTable <- addMotifAnnotation(auc=motifs_AUC,
     nesThreshold=nesThreshold,
     motifAnnot=motifAnnot,
     motifAnnot_highConfCat=motifAnnot_highConfCat,
     motifAnnot_lowConfCat=motifAnnot_lowConfCat,
     highlightTFs=highlightTFs)
  
  # Identify significant genes for each motif
  # (i.e. genes from the gene set in the top of the ranking)
  motifEnrichmentTable_wGenes <- addSignificantGenes(
     resultsTable=motifEnrichmentTable,
     geneSets=geneSets,
     rankings=motifRankings,
     maxRank=geneErnMaxRank,
     plotCurve=FALSE, genesFormat="geneList",
     method=geneErnMethod, nCores=nCores)
}

# test_Workflow() calls:
## .check_calcAUC()
## .check_addSignificantGenes()
## .check_addMotifAnnotation()
## .check_motifEnrichmentTable()
.check_calcAUC <- function(motifRankings)
{
  motifRankings
  
  correctNmotifs <- nrow(motifRankings)
  
  # a) Character vector (i.e. only one gene-set)
  fewGenes <- sample(colnames(getRanking(motifRankings)), 10)
  motifsAUC <- suppressWarnings(calcAUC(fewGenes, motifRankings, aucMaxRank=5))
  
  testthat::expect_equal(nrow(motifsAUC), 1)
  testthat::expect_equal(ncol(motifsAUC), correctNmotifs)
  
  # b) List
  otherGenes <- sample(colnames(getRanking(motifRankings)), 5)
  geneSets <- list(geneSet1=fewGenes,
                   geneSet2=otherGenes)
  motifsAUC <- suppressWarnings(calcAUC(geneSets, motifRankings, aucMaxRank=5))
  
  testthat::expect_equal(nrow(motifsAUC), 2)
  testthat::expect_equal(ncol(motifsAUC), correctNmotifs)
  
  # c) GeneSet object (from GSEABase)
  geneSetOne <- GSEABase::GeneSet(fewGenes, setName="geneSetOne")
  motifsAUC <- suppressWarnings(calcAUC(geneSetOne, motifRankings, aucMaxRank=5))
  
  testthat::expect_equal(nrow(motifsAUC), 1)
  testthat::expect_equal(ncol(motifsAUC), correctNmotifs)
  
  # d) GeneSetCollection object (from GSEABase)
  geneSetTwo <- GSEABase::GeneSet(otherGenes, setName="geneSetTwo")
  geneSets <- GSEABase::GeneSetCollection(geneSetOne, geneSetTwo)
  motifsAUC <- suppressWarnings(calcAUC(geneSets, motifRankings, aucMaxRank=5))
  
  testthat::expect_equal(nrow(motifsAUC), 2)
  testthat::expect_equal(ncol(motifsAUC), correctNmotifs)
  
  testthat::expect_equal(class(motifsAUC)[1], "aucScores")
  testthat::expect_equal(SummarizedExperiment::assayNames(motifsAUC)[1], "AUC")
  
  ### Max aucMaxRank
  testthat::expect_error(calcAUC(geneSets, motifRankings, nCores=1, aucMaxRank=100000))
  
  ### Multicore
  motifsAUC_multicore <- suppressWarnings(calcAUC(geneSets, motifRankings, aucMaxRank=5, nCores=2))
  testthat::expect_equal(getAUC(motifsAUC), getAUC(motifsAUC_multicore))
}

.check_addSignificantGenes <- function(met, motifRankings, geneLists)
{
  motifEnrichmentTable_wGenes <- addSignificantGenes(met[1:3,],
                                                     plotCurve=TRUE,
                                                     geneSets=geneLists,
                                                     rankings=motifRankings,
                                                     method="aprox",
                                                     genesFormat="geneList")
  
  expect_equal(class(motifEnrichmentTable_wGenes)[1], "data.table")
  
  motifEnrichmentTable_wGenes <- as.data.frame(motifEnrichmentTable_wGenes)
  expect_equal(colnames(motifEnrichmentTable_wGenes),
               c("geneSet", "motif", "NES", "AUC", "TF_highConf","TF_lowConf", 
                 "nEnrGenes", "rankAtMax", "enrichedGenes"))
  
  # As incidence matrix
  motifEnr_wIncidMat <- addSignificantGenes(met[1:3,],
                                            geneSets=geneLists,
                                            rankings=motifRankings,
                                            method="aprox",
                                            genesFormat = "incidMatrix")
  expect_true(ncol(motifEnr_wIncidMat)>7)
  
  ############# getSignificantGenes #########
  selectedMotif <- met$motif[1:2]
  onlyGenes <- getSignificantGenes(geneSet=geneLists$hypoxia,
                                   signifRankingNames=selectedMotif,
                                   genesFormat="incidMatrix",
                                   plotCurve=FALSE,
                                   maxRank=4500,
                                   rankings=motifRankings,
                                   method="aprox")
  
  
  ### Diferent input formats (geneSet)
  # a) Character vector (i.e. only one gene-set)
  fewGenes <- sample(colnames(getRanking(motifRankings)), 10)
  gsOut <- getSignificantGenes(geneSet=fewGenes, signifRankingNames=selectedMotif[1], maxRank=4500,
                               genesFormat="incidMatrix", plotCurve=FALSE, rankings=motifRankings, method="aprox")
  
  testthat::expect_equal(names(gsOut), c("enrStats", "incidMatrix"))
  
  # b) List
  otherGenes <- sample(colnames(getRanking(motifRankings)), 5)
  geneSets <- list(geneSet1=fewGenes,
                   geneSet2=otherGenes)
  expect_error(getSignificantGenes(geneSet=geneSets, signifRankingNames=selectedMotif[1], maxRank=4500,
                                   genesFormat="incidMatrix", plotCurve=FALSE, rankings=motifRankings, method="aprox"))
  gsOut <- getSignificantGenes(geneSet=geneSets[1], signifRankingNames=selectedMotif[1], maxRank=4500,
                               genesFormat="incidMatrix", plotCurve=FALSE, rankings=motifRankings, method="aprox")
  testthat::expect_equal(names(gsOut), c("enrStats", "incidMatrix"))
  
  # c) GeneSet object (from GSEABase)
  geneSetOne <- GSEABase::GeneSet(fewGenes, setName="geneSetOne")
  gsOut <- getSignificantGenes(geneSet=geneSetOne, signifRankingNames=selectedMotif[1], maxRank=4500,
                               genesFormat="incidMatrix", plotCurve=FALSE, rankings=motifRankings, method="aprox")
  
  testthat::expect_equal(names(gsOut), c("enrStats", "incidMatrix"))
  
  
  # d) GeneSetCollection object (from GSEABase)
  geneSetTwo <- GSEABase::GeneSet(otherGenes, setName="geneSetTwo")
  geneSets <- GSEABase::GeneSetCollection(geneSetOne, geneSetTwo)
  
  expect_error(getSignificantGenes(geneSet=geneSets, signifRankingNames=selectedMotif[1],
                                   genesFormat="incidMatrix", plotCurve=FALSE, rankings=motifRankings, method="aprox"))
  gsOut <- getSignificantGenes(geneSet=geneSets[1], signifRankingNames=selectedMotif[1],
                               genesFormat="incidMatrix", plotCurve=FALSE, rankings=motifRankings, method="aprox")
  testthat::expect_equal(names(gsOut), c("enrStats", "incidMatrix"))
  
  
  ### Max aucMaxRank
  testthat::expect_error(getSignificantGenes(geneLists,motifRankings,
                                             signifRankingNames=selectedMotifs, plotCurve=TRUE, genesFormat="none",
                                             maxRank=50000, method="iCisTarget"))
  
  testthat::expect_error(getSignificantGenes(geneLists,motifRankings,
                                             signifRankingNames=selectedMotifs, plotCurve=TRUE, genesFormat="none",
                                             maxRank=50000, method="aprox"))
  
  testthat::expect_error(addSignificantGenes(motifEnrichmentTable,
                                             geneSets=geneLists, rankings=motifRankings, nCores=1,
                                             maxRank=50000, method="aprox"))
}

.check_addMotifAnnotation <- function(motifs_AUC, motifAnnot)
{
  # No annot
  motifEnrichmentTable_noAnnot <- addMotifAnnotation(motifs_AUC)
  .check_motifEnrichmentTable(met=motifEnrichmentTable_noAnnot, motifAnnot=NULL)
  
  # provide annotation but confCat=NULL
  motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                                             motifAnnot=motifAnnot,
                                             motifAnnot_highConfCat=NULL,
                                             motifAnnot_lowConfCat=NULL)
  .check_motifEnrichmentTable(met=motifEnrichmentTable,
                              motifAnnot=motifAnnot,
                              motifAnnot_highConfCat=NULL,
                              motifAnnot_lowConfCat=NULL)
  
  motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                                             motifAnnot=motifAnnot,
                                             motifAnnot_highConfCat=NULL)
  .check_motifEnrichmentTable(met=motifEnrichmentTable,
                              motifAnnot=motifAnnot,
                              motifAnnot_highConfCat=NULL)
  
  # including annotation 
  motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                                             motifAnnot=motifAnnot)
  .check_motifEnrichmentTable(met=motifEnrichmentTable, motifAnnot=motifAnnot)
  
  # some other options
  motifEnrichment_wIndirect <- suppressWarnings(addMotifAnnotation(motifs_AUC, 
                                                                   nesThreshold=2, motifAnnot=motifAnnot,
                                                                   highlightTFs = "HIF1A", digits=3))
  .check_motifEnrichmentTable(met=motifEnrichment_wIndirect, 
                              motifAnnot=motifAnnot,
                              highlightTFs="HIF1A")
  expect_true(min(motifEnrichment_wIndirect$NES)>=2)
}


.check_motifEnrichmentTable <- function(met, motifAnnot=NULL, 
                                        motifAnnot_highConfCat=c("directAnnotation", "inferredBy_Orthology"),
                                        motifAnnot_lowConfCat=c("inferredBy_MotifSimilarity",
                                                                "inferredBy_MotifSimilarity_n_Orthology"),
                                        highlightTFs=NULL)
{
  nCols <- 4
  
  if(!is.null(motifAnnot)) {
    
    if(!is.null(motifAnnot_highConfCat))
    {
      nCols <- nCols+1
      expect_true("TF_highConf" %in% colnames(met)) 
      
      # check content (not very exhaustive)
      expect_true(any(vapply(paste0(" (", motifAnnot_highConfCat,")."), 
                             function(x) any(grepl(x, met$TF_highConf, fixed=TRUE)), TRUE)))
      
      expect_false(any(vapply(paste0(" (", motifAnnot_lowConfCat,")."), 
                              function(x) any(grepl(x, met$TF_highConf, fixed=TRUE)), TRUE)))
    }
    
    if(!is.null(motifAnnot_lowConfCat))
    {
      nCols <- nCols+1
      expect_true("TF_lowConf" %in% colnames(met)) 
      
      # check content (not very exhaustive)
      expect_true(any(vapply(paste0(" (", motifAnnot_lowConfCat,")."), 
                             function(x) any(grepl(x, met$TF_lowConf, fixed=TRUE)), TRUE)))
      
      expect_false(any(vapply(paste0(" (", motifAnnot_highConfCat,")."), 
                              function(x) any(grepl(x, met$TF_lowConf, fixed=TRUE)), TRUE)))
    }
  }
  
  if(!is.null(highlightTFs)) {
    nCols <- nCols+2
    expect_true("highlightedTFs" %in% colnames(met))
    expect_true(all(met$highlightedTFs=="HIF1A"))
  }
  
  expect_equal(class(met)[1], "data.table")
  expect_equal(ncol(met), nCols)
  expect_equal(colnames(met)[1:4], c("geneSet", "motif", "NES", "AUC"))
}

test_Workflow <- function()
{
  library(RcisTarget)
  
  ##### Example setup ##############################
  txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                   "hypoxiaGeneSet.txt", sep="/")
  geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors = FALSE)[,1])

  # Load databases
  library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
  data(hg19_500bpUpstream_motifRanking_cispbOnly)
  motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly
  
  ##################################################
  # Standard workflow
  # (To use as input for the different check functions)
  # Step 1.

  .check_calcAUC(motifRankings) # Checks different intput/ouputs for calcAUC
  motifs_AUC <- calcAUC(geneLists, motifRankings) # For input of next steps

  # Step 2.
  data(hg19_motifAnnotation_cisbpOnly)
  .check_addMotifAnnotation(motifs_AUC, 
                            motifAnnot=hg19_motifAnnotation_cisbpOnly)
  motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                            motifAnnot=hg19_motifAnnotation_cisbpOnly)

  # Step 3
  .check_addSignificantGenes(met=motifEnrichmentTable, 
                             motifRankings=motifRankings, geneLists=geneLists)
  motifEnrichmentTable_wGenes <- addSignificantGenes(
                            resultsTable=motifEnrichmentTable,
                            geneSets=geneLists,
                            rankings=motifRankings,
                            method="aprox")
  ##################################################


  ##################################################
  # cisTarget (automated workflow)
  motifEnrichmentTable_wGenes <- cisTarget(geneLists, motifRankings,
                     motifAnnot=hg19_motifAnnotation_cisbpOnly,
                     nesThreshold=3.5, geneErnMethod="aprox", nCores=4)

  expect_equal(colnames(motifEnrichmentTable_wGenes),
               c("geneSet", "motif", "NES", "AUC", "TF_highConf", "TF_lowConf", 
                 "nEnrGenes", "rankAtMax", "enrichedGenes"))
  ##################################################


  motifEnrichmentTable_wLogo <- addLogo(motifEnrichmentTable)
}

test_that("RcisTarget workflow tests", test_Workflow())

#' @title convertToTargetRegions
#' @description Convert a set of input regions to the overlapping regions in the target set.
#' @param queryRegions List of regions to convert (normally the query region set).
#' @param targetRegions List of regions in the target set (normally the database).
#' @param minOverlap Minimum overlap to consider (in either direction, default: 0.40).
#' @param overlapType Parameter for \code{findOverlaps} (default: "any")
#' @param returnCorrespondence Returns a table containing the matches, 
#' or only a list of overlapping regions (default: FALSE).
#' @param verbose Print the number of regions selected?
#' @return IDs of the regions in the "target regions" overlapping with the query regions.
#' @seealso \code{\link{getDbRegionsLoc}}.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("RcisTarget")}
#'
#' @examples
#' \dontrun{
#'  ## To apply on a list of regionSets:
#'  regionSets_db <- lapply(regionSets, function(x) 
#'     convertToTargetRegions(queryRegions=x, targetRegions=dbRegionsLoc))
#'  }
#' @rdname convertToTargetRegions
#' @importFrom methods isClass
#' @importFrom GenomeInfoDb keepSeqlevels
#' @importFrom GenomicRanges findOverlaps width pintersect
#' @importFrom S4Vectors queryHits subjectHits elementMetadata
#' @export
convertToTargetRegions <- function(queryRegions, targetRegions, minOverlap=0.4, overlapType="any", returnCorrespondence=FALSE, verbose=TRUE)
{
  ### Check types
  if(!is.numeric(minOverlap) || (minOverlap<0 && minOverlap>=1)) stop("minOverlap should be a number between 0 and 1 (percentage of overlap between the regions).")
  if(!isClass(targetRegions, "GRanges")) targetRegions <- GRanges(targetRegions)
  if(!isClass(queryRegions, "GRanges")) queryRegions <- GRanges(queryRegions)
  ###
  
  seqlvls <- intersect(seqlevels(queryRegions), seqlevels(targetRegions))
  queryRegions <- GenomeInfoDb::keepSeqlevels(queryRegions, seqlvls, pruning.mode = "coarse")
  overlapHits <- GenomicRanges::findOverlaps(queryRegions, targetRegions,
                              minoverlap=1,  
                              type=overlapType, select="all", ignore.strand=TRUE)
  
  if(minOverlap>0)
  {
    # In i-cisTarget, the default is 40% minimum overlap. Both ways: It takes the maximum percentage (of the peak or the ict region)
    # To reproduce those results:
    overlaps <- GenomicRanges::pintersect(queryRegions[queryHits(overlapHits)], targetRegions[subjectHits(overlapHits)])
    percentOverlapDb <- GenomicRanges::width(overlaps) / GenomicRanges::width(targetRegions[subjectHits(overlapHits)])
    percentOverlapQuery <- GenomicRanges::width(overlaps) / GenomicRanges::width(queryRegions[queryHits(overlapHits)])
    maxOverlap <- apply(cbind(percentOverlapDb, percentOverlapQuery), 1, max)
    overlapHits <- overlapHits[maxOverlap > 0.4]
  }
  
  # Get regions names
  dbHits <- targetRegions[subjectHits(overlapHits)]
  if("name" %in% colnames(elementMetadata(dbHits)))
  {
    dbHits <- as.character(dbHits$name)
  }else{
    dbHits <- as.character(dbHits)
  }
  ret <- unique(dbHits)
  if(verbose) message(paste("Number of regions selected: ", length(ret)))
  
  if(returnCorrespondence) 
  {
    queryHits <- queryRegions[queryHits(overlapHits)]
    ret <- cbind(query=unname(as.character(queryHits)), db=unname(dbHits))
  }
  
  return(ret)
}

# Max ranking to calculate the enrichment

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)

#' @rawNamespace import(GSEABase, except = c(union, intersect, setdiff))
#' @importFrom methods new
#' @importFrom graphics lines plot points polygon
#' @importFrom utils installed.packages
#' @importFrom tibble as_tibble
#'
#' @title Add significant genes
#' @description Identify which genes (of the gene-set) are highly ranked
#' for each motif.
#'
#' \itemize{
#'   \item addSignificantGenes(): adds them to the results table.
#'   \item getSignificantGenes():
#'   Calculates the significant genes for ONE gene set.
#'   It provides the plot and the gene list (it is used by addSignificantGenes).
#' }
#' @param resultsTable [addSignificantGenes]
#' Output table from \code{\link{addMotifAnnotation}}
#' @param geneSets [addSignificantGenes] List of gene-sets which was analyzed.
#' @param rankings Motif rankings used to analyze the gene list
#' (They should be the same as used for calcAUC in this same analysis).
#' @param maxRank Maximum rank to take into account for the recovery curve
#' (Default: 5000).
#' @param plotCurve Logical. Wether to plot the recovery curve (Default: FALSE).
#' @param genesFormat "geneList" or "incidMatrix". Format to return the genes
#' (Default: "geneList").
#' @param method "iCisTarget" or "aprox". There are two methods to identify the
#'  highly ranked genes:
#'   (1) equivalent to the ones used in iRegulon and i-cisTarget
#'   (method="iCisTarget", recommended if running time is not an issue),
#'   and (2) a faster implementation based on an approximate distribution
#'   using the average at each rank (method="aprox",
#'   useful to scan multiple gene sets). (Default: "aprox")
#' @param nMean Only used for "aprox" method: Interval to calculate the running
#' mean and sd. Default: 50 (aprox. nGenesInRanking/400).
#' @param nCores Number of cores to use for parallelization (Default: 1).
#' @param geneSet [getSignificantGenes] Gene-set to analyze (Only one).
#' @param signifRankingNames [getSignificantGenes] Motif ranking name.
#' @param digits  [getSignificantGenes]
#' Number of digits to include in the output.
#' @return Output from \code{\link{addMotifAnnotation}}
#' adding the folowing columns:
#' \itemize{
#'   \item nEnrGenes: Number of genes highly ranked
#'   \item rankAtMax: Ranking at the maximum enrichment,
#'   used to determine the number of enriched genes.
#'   \item enrichedGenes: Genes that are highly ranked for the given motif.
#'   If genesFormat="geneList", the gene names are collapsed into a comma
#'   separated text field (alphabetical order). If genesFormat="incidMatrix",
#'   they are formatted as an indicence matrix, i.e. indicanting with 1 the
#'   genes present, and 0 absent.
#' }
#' @return If plotCurve=TRUE, the recovery curve is plotted.
#' @details
#' The highly ranked genes are selected based on the distribution of the
#' recovery curves of the gene set across all the motifs in the database.
#' In the plot, the red line indicates the average of the recovery curves of
#' all the motifs, the green line the average + standard deviation, and the
#' blue line the recovery curve of the current motif.
#' The point of maximum distance between the current motif and the green curve
#' (mean+sd), is the rank selected as maximum enrichment.
#' All the genes with lower rank will be considered enriched.
#'
#' Depending on whether the method is "iCisTarget" or "aprox", the mean and
#' SD at each rank are calculated slightly different.
#' "iCisTarget" method calculates the recovery curves for all the motifs, and
#'  then calculates the average and SD at each rank.
#' Due to the implementation of the function in R, this method is slower than
#' just subsetting the ranks of the genes in for each motif,
#' and calculating the average of the available ones at each position with a
#' sliding window.
#' Since there are over 18k motifs, the chances of getting several measures at
#' each rank are very high and highly resemble the results calculated
#' by iCisTarget, though they are often not exactly the same
#' (hence the name: "aprox" method).

#' @seealso Previous step in the workflow: \code{\link{addMotifAnnotation}}.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("RcisTarget")}
#' @example inst/examples/example_addSignificantGenes.R
#' @export
#'
#' @export
setGeneric("addSignificantGenes", signature="geneSets",
           function(resultsTable, geneSets, rankings, maxRank=5000, plotCurve=FALSE,
                    genesFormat="geneList", method="aprox", nMean=50, nCores=1)
           {
             standardGeneric("addSignificantGenes")
           })

#' @rdname addSignificantGenes
#' @aliases addSignificantGenes,list-method
setMethod("addSignificantGenes", "list",
          function(resultsTable, geneSets, rankings, maxRank=5000, plotCurve=FALSE,
                   genesFormat="geneList", method="aprox", nMean=50, nCores=1)
          {
            .addSignificantGenes(resultsTable=resultsTable,
                                 geneSets=geneSets,
                                 rankings=rankings,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 method=method,
                                 nMean=nMean,
                                 nCores=nCores)
          })

#' @rdname addSignificantGenes
#' @aliases addSignificantGenes,character-method
setMethod("addSignificantGenes", "character",
          function(resultsTable, geneSets, rankings, maxRank=5000, plotCurve=FALSE,
                   genesFormat="geneList", method="aprox", nMean=50, nCores=1)
          {
            geneSets <- list(geneSet=geneSets)
            
            .addSignificantGenes(resultsTable=resultsTable,
                                 geneSets=geneSets,
                                 rankings=rankings,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 method=method,
                                 nMean=nMean,
                                 nCores=nCores)
          })

#' @rdname addSignificantGenes
#' @aliases addSignificantGenes,GeneSet-method
setMethod("addSignificantGenes", "GeneSet",
          function(resultsTable, geneSets, rankings, maxRank=5000, plotCurve=FALSE,
                   genesFormat="geneList", method="aprox", nMean=50, nCores=1)
          {
            geneSets <- setNames(list(GSEABase::geneIds(geneSets)),
                                 GSEABase::setName(geneSets))
            
            .addSignificantGenes(resultsTable=resultsTable,
                                 geneSets=geneSets,
                                 rankings=rankings,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 method=method,
                                 nMean=nMean,
                                 nCores=nCores)
          })

#' @rdname addSignificantGenes
#' @aliases addSignificantGenes,GeneSetCollection-method
setMethod("addSignificantGenes", "GeneSetCollection",
          function(resultsTable, geneSets, rankings, maxRank=5000,
                   plotCurve=FALSE, genesFormat="geneList", method="aprox", nMean=50, nCores=1)
          {
            geneSets <- GSEABase::geneIds(geneSets)
            
            .addSignificantGenes(resultsTable=resultsTable,
                                 geneSets=geneSets,
                                 rankings=rankings,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 method=method,
                                 nMean=nMean,
                                 nCores=nCores)
          })

.addSignificantGenes <- function(resultsTable, geneSets, rankings,
                                 maxRank=5000, plotCurve=FALSE, genesFormat="geneList",
                                 method="aprox", nMean=50, nCores=1)
{
  if(!"geneSet" %in% colnames(resultsTable)) stop("There is no column 'geneSet' in the input results table. Please, confirm its format.")
  method <- tolower(method[1])
  if(!method %in% c("icistarget", "icistargetaprox", "aprox"))
    stop("'method' should be either 'iCisTarget' or 'iCisTargetAprox'.")
  
  resultsTable$geneSet <- as.character(resultsTable$geneSet)
  geneSetNames <- as.character(unique(resultsTable$geneSet))
  if(any(!geneSetNames %in% names(geneSets))) stop("Missing gene sets: ", paste(geneSetNames[which(!geneSetNames %in% names(geneSets))], collapse=", "))
  
  if(isS4(rankings)) {
    .maxRank.check(maxRank, rankings, method, nMean)
    rankings <- getRanking(rankings)
  }
  
  rnkType <- c("ranking", "motif")
  rnkType <- rnkType[which(rnkType %in% colnames(resultsTable))]
  
  # (Paralelized inside enrichment function)
  signifMotifsAsList <- lapply(geneSetNames, function(gsn)
  {
    enrRnkT_ByGs <- resultsTable[which(resultsTable$geneSet==gsn),]
    
    geneSet <- as.character(geneSets[[unique(as.character(enrRnkT_ByGs$geneSet))]])
    signifGenes <- .getSignificantGenes(
      geneSet=geneSet,
      rankings=rankings,
      signifRankingNames=unname(unlist(subset(enrRnkT_ByGs,
                                              select=rnkType))),
      method=method,
      maxRank=maxRank,
      plotCurve=plotCurve,
      genesFormat=genesFormat,
      nCores=nCores, digits=3, nMean=nMean)
    
    enrRnkT_ByGs <- cbind(enrRnkT_ByGs, tibble::as_tibble(signifGenes$enrStats))
    if("geneList" %in% genesFormat){
      enrichedGenes <- tibble::as_tibble(vapply(signifGenes$enrichedGenes,
                               function(x) paste(unlist(x), collapse=";"),
                               FUN.VALUE=""))
      colnames(enrichedGenes) <- "enrichedGenes"
      enrRnkT_ByGs <- cbind(enrRnkT_ByGs, enrichedGenes)
    }
    if("incidMatrix" %in% genesFormat)
      enrRnkT_ByGs <- cbind(enrRnkT_ByGs, tibble::as_tibble(signifGenes$incidMatrix))
    enrRnkT_ByGs
  })
  
  signifMotifsAsList <- data.table::rbindlist(signifMotifsAsList)
  attr(signifMotifsAsList, "annotationVersion") <- attr(resultsTable, "annotationVersion")
  
  return(signifMotifsAsList)
}

#' @rdname addSignificantGenes
#' @export
setGeneric("getSignificantGenes", signature="geneSet",
           function(geneSet, rankings, signifRankingNames=NULL, method="iCisTarget",
                    maxRank=5000, plotCurve=FALSE, genesFormat=c("geneList", "incidMatrix"),
                    nCores=1, digits=3, nMean=50)
           {
             standardGeneric("getSignificantGenes")
           })

#' @rdname addSignificantGenes
#' @aliases getSignificantGenes,list-method
setMethod("getSignificantGenes", "list",
          function(geneSet, rankings, signifRankingNames=NULL, method="iCisTarget",
                   maxRank=5000, plotCurve=FALSE, genesFormat=c("geneList", "incidMatrix"),
                   nCores=1, digits=3, nMean=50)
          {
            if(length(geneSet)>1) stop("Provide only one gene set.")
            geneSet <- as.character(unname(unlist(geneSet)))
            .getSignificantGenes(geneSet=geneSet,
                                 rankings=rankings,
                                 signifRankingNames=signifRankingNames,
                                 method=method,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 nCores=nCores,
                                 digits=digits,
                                 nMean=nMean)
          })

#' @rdname addSignificantGenes
#' @aliases getSignificantGenes,character-method
setMethod("getSignificantGenes", "character",
          function(geneSet, rankings, signifRankingNames=NULL, method="iCisTarget",
                   maxRank=5000, plotCurve=FALSE, genesFormat=c("geneList", "incidMatrix"),
                   nCores=1, digits=3, nMean=50)
          {
            .getSignificantGenes(geneSet=geneSet,
                                 rankings=rankings,
                                 signifRankingNames=signifRankingNames,
                                 method=method,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 nCores=nCores,
                                 digits=digits,
                                 nMean=nMean)
          })

#' @rdname addSignificantGenes
#' @aliases getSignificantGenes,factor-method
setMethod("getSignificantGenes", "factor",
          function(geneSet, rankings, signifRankingNames=NULL, method="iCisTarget",
                   maxRank=5000, plotCurve=FALSE, genesFormat=c("geneList", "incidMatrix"),
                   nCores=1, digits=3, nMean=50)
          {
            geneSet <- as.character(geneSet)
            .getSignificantGenes(geneSet=geneSet,
                                 rankings=rankings,
                                 signifRankingNames=signifRankingNames,
                                 method=method,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 nCores=nCores,
                                 digits=digits,
                                 nMean=nMean)
          })

#' @rdname addSignificantGenes
#' @aliases getSignificantGenes,GeneSet-method
setMethod("getSignificantGenes", "GeneSet",
          function(geneSet, rankings, signifRankingNames=NULL, method="iCisTarget",
                   maxRank=5000, plotCurve=FALSE, genesFormat=c("geneList", "incidMatrix"),
                   nCores=1, digits=3, nMean=50)
          {
            geneSet <- GSEABase::geneIds(geneSet)
            
            .getSignificantGenes(geneSet=geneSet,
                                 rankings=rankings,
                                 signifRankingNames=signifRankingNames,
                                 method=method,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 nCores=nCores,
                                 digits=digits,
                                 nMean=nMean)
          })

#' @rdname addSignificantGenes
#' @aliases getSignificantGenes,GeneSetCollection-method
setMethod("getSignificantGenes", "GeneSetCollection",
          function(geneSet, rankings, signifRankingNames=NULL, method="iCisTarget",
                   maxRank=5000, plotCurve=FALSE, genesFormat=c("geneList", "incidMatrix"),
                   nCores=1, digits=3, nMean=50)
          {
            if(length(geneSet)>1) stop("Provide only one gene set.")
            geneSet <- unlist(GSEABase::geneIds(geneSet))
            
            .getSignificantGenes(geneSet=geneSet,
                                 rankings=rankings,
                                 signifRankingNames=signifRankingNames,
                                 method=method,
                                 maxRank=maxRank,
                                 plotCurve=plotCurve,
                                 genesFormat=genesFormat,
                                 nCores=nCores,
                                 digits=digits,
                                 nMean=nMean)
          })

.getSignificantGenes <- function(geneSet,
                                 rankings,
                                 signifRankingNames=NULL,
                                 method="iCisTarget",
                                 maxRank=5000,
                                 plotCurve=FALSE,
                                 genesFormat=c("geneList", "incidMatrix"),
                                 nCores=1,
                                 digits=3,
                                 nMean=50)
{
  ############################################################################
  # Argument checks & init. vars
  # aucThreshold <- 0.05*nrow(rankings)
  method <- tolower(method[1])
  if(!method %in% c("icistarget", "icistargetaprox", "aprox"))
    stop("'method' should be either 'iCisTarget' or 'iCisTargetAprox'.")
  
  maxRank <- round(maxRank)
  if(isS4(rankings)) {
    .maxRank.check(maxRank, rankings, method, nMean)
    rankings <- getRanking(rankings)
  }
  
  indexCol <- colnames(rankings)[1]
  
  if(is.null(signifRankingNames)) {
    signifRankingNames <- rankings[,indexCol]
    warning("'signifRankingNames' has not been provided.",
            "The significant genes will be calculated for all rankings.")
  }
  signifRankingNames <- as.character(unname(signifRankingNames))
  if(any(!signifRankingNames %in% rankings[[indexCol]])) 
    stop("Some 'signifRankingNames' are missing from the ranking.")
  
  if(!all(genesFormat %in% c("geneList", "incidMatrix", "none")))
    stop('"genesFormat" should be ither "geneList" and/or "incidMatrix".')
  
  if(method == "icistarget") {
    calcEnrFunct <- .calcEnr_iCisTarget
  } else {
    calcEnrFunct <- .calcEnr_Aprox
    
    if(!requireNamespace("zoo", quietly=TRUE))
      stop("Package 'zoo' is required ",
           "to calculate the aproximate RCC distributions.",
           "To install it, run:\t install.packages('zoo')")
  }
  
  # Remove missing genes from geneSet...
  geneSet <- unique(geneSet)
  geneSet <- geneSet[which(geneSet %in% colnames(rankings)[-1])]
  
  motifNames <- as.character(unlist(rankings[,indexCol]))
  gSetRanks <- data.frame(row.names=motifNames, rankings[,geneSet])
  rm(rankings)
  
  #############################################################################
  # Calculate enrichment
  enrStats <- t(calcEnrFunct(gsRankings=gSetRanks,
                             maxRank,
                             signifRankingNames,
                             plotCurve,
                             nCores,
                             nMean))
  enrStats <- enrStats[,c("y", "x"), drop=FALSE]
  colnames(enrStats) <- c("nEnrGenes", "rankAtMax")
  
  enrichedGenes <- list()
  if("incidMatrix" %in% genesFormat)
    incidMatrix <- matrix(0, nrow=length(signifRankingNames),
                          ncol=length(geneSet),
                          dimnames=list(signifRankingNames, sort(geneSet)))
  for(rankingName in signifRankingNames)
  {
    # geneSet should be in the same order as colnames(gSetRanks)
    # geneSet==colnames(gSetRanks) #but might not be the same if dashes
    enrichedGenes[[rankingName]] <- sort(geneSet[
      which(gSetRanks[rankingName,] <= enrStats[rankingName, "rankAtMax"])])
    if("incidMatrix" %in% genesFormat)
      incidMatrix[rankingName, enrichedGenes[[rankingName]]] <- 1
  }
  
  #############################################################################
  # Return
  ret <- list(enrStats=enrStats) #data.table(enrStats, keep.rownames=TRUE))
  if("geneList" %in% genesFormat)
    ret <- c(ret, enrichedGenes=list(enrichedGenes))
  if("incidMatrix" %in% genesFormat)
    ret <- c(ret, incidMatrix=list(incidMatrix))
  if(any(tolower(genesFormat) != "none"))
    return(ret)
}


.maxRank.check <- function(maxRank, rankings, method, nMean){
  maxRankInDb <- min(c(getMaxRank(rankings), getNumColsInDB(rankings)))
  if(maxRankInDb < Inf)
  {
    if(method %in% c("icistarget")){
      if(maxRank > maxRankInDb)
        stop("maxRank (", maxRank, ") should not be bigger ",
             "than the maximum ranking available in the database (",
             maxRankInDb,")")
    }
    
    if(method %in% c("icistargetaprox", "aprox")){
      if(maxRank+nMean > maxRankInDb)
        stop("maxRank + nMean (", maxRank+nMean, ") should not be bigger ",
             "than the maximum ranking available in the database (",
             maxRankInDb,")")
    }
  }
  return(NULL)
}

#' @title Gets the region location for the given database IDs.
#' @description
#' Gets the region location based on the region ID.
#' Only needed for drosophila\bold{drosophila} (fruit fly) regions.
#' 
#' For \bold{human/mouse} the region locations are stored in a separate object 
#' (i.e. \code{}). This function is not needed.
#' @param featherFilePath Path to the rankings database
#' @param spltChr Character(s) used to split the prefix from the region location.
#' The default is used for current Drosophila versions. Use NULL to skip.
#' @param indexCol Column name including the motif/feature IDs. By default it will use the first column.
#' @return The region locations in a GRanges object, with the original region ID as name.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("RcisTarget")}
#'
#' @examples
#' \dontrun{
#' featherFilePath <- "~/databases/dm6-regions-11species.mc9nr.feather"
#' dbRegionsLoc <- getDbRegionsLoc(featherFilePath)
#' }
#' @rdname getDbRegionsLoc
#' @importFrom GenomeInfoDb sortSeqlevels seqlevels 
#' @importFrom GenomicRanges GRanges
#' @export
getDbRegionsLoc <- function(featherFilePath, spltChr="__", indexCol=NULL)
{
  featherFilePath <- path.expand(featherFilePath)
  
  dbCols <- getColumnNames(featherFilePath)
  indexCol <- .getIndexCol(dbCols, indexCol=indexCol, verbose=FALSE)
  
  dbCols <- setdiff(dbCols, indexCol); length(dbCols)
  dbCols <- setNames(dbCols, dbCols)
  
  if(!is.null(spltChr)) dbCols <- sapply(strsplit(dbCols, spltChr), function(x) x[[2]])
  dbRegions <- GenomicRanges::GRanges(unname(dbCols), name=names(dbCols))
  dbRegions <- GenomeInfoDb::sortSeqlevels(dbRegions)
  return(dbRegions)
}

#' @title Imports the annotations of motifs to transcription factors 
#' @aliases importAnnotations
#' @param annotFile File containing the motif annotations corresponding to the
#' rankings. They should match in organism and version. 
#' @param motifsInRanking Subset of motifs to keep.
#' e.g. 
#' \code{motifsInRanking=getRanking(motifRankings)$features}
#' @param columnsToKeep Other colums from the file to keep
#' 
#' @description RcisTarget package includes the motif annotations for the rankings 
#' using the latest motif collection (version 10 clustered, 19895 motifs): 
#' 
#' \itemize{
#' \item{Human: }{ \code{data(motifAnnotations_hgnc)}}
#' \item{Mouse: }{ \code{data(motifAnnotations_mgi)}}
#' \item{Fly: }{ \code{data(motifAnnotations_dmel)}}
#' 
#' \item{Previous versions (Annotations for motif collection version 9 (24453 motifs) or 8:}{
#' motifAnnotations_hgnc_v9 (Human), motifAnnotations_mgi_v9 (Mouse), motifAnnotations_dmel_v9 (Fly)
#' motifAnnotations_hgnc_v8 (Human), motifAnnotations_mgi_v8 (Mouse), motifAnnotations_dmel_v8 (Fly)
#' }
#' }
#' 
#' This function (importAnnotations) allows to import annotations 
#' for other versions of the rankings, or to keep extra data columns.
#' 
#' e.g. Source of the annotations: \code{https://resources.aertslab.org/cistarget/motif2tf/}
#' 
#' @seealso See \emph{iRegulon} paper and documentation for \bold{details} on how the
#' rankings and annotations were built.
#' @return
#' data.table with the annotations of the motifs to transcription factors
#' 
#' Columns:
#'  \itemize{
#'    \item{\bold{motif}: }{Motif ID.}
#'    \item{\bold{TF}: }{Transcription factor (or inferred gene).}
#'    \item{\bold{directAnnotation}, \bold{inferred_Orthology}, 
#'      \bold{inferred_MotifSimil}: }{
#'        Boolean values indicating whether the motif is 
#'        annotated to the TF in the source database ("directAnnotation"), 
#'        or whether it was inferred by orthology ("inferred_Orthology") 
#'        or motif similarity ("inferred_MotifSimil").}
#'    \item{\bold{Description}: }{Description of the source of the annotation.}
#'    \item{\bold{annotationSource}: }{Source of the annotation 
#'      formatted as factor (e.g. for subsetting). 
#'      Levels: directAnnotation, inferredBy_Orthology, 
#'      inferredBy_MotifSimilarity, inferredBy_MotifSimilarity_n_Orthology.}
#'  }
#' 
#' @examples
#' # motifAnnotations <- importAnnotations("motifs-v10nr_clust-nr.hgnc-m0.001-o0.0.tbl")
#' 
#' ## To save (decrease from ~100MB to 1MB): 
#' # save(motifAnnotations, file="motifAnnotations_hngc.RData", compress='xz')
#' 
#' # This code would generate the equivalent to
#' data(motifAnnotations_hgnc)


#' @rdname importAnnotations
#' @rawNamespace import(data.table, except = c(shift, last, first, between))
#' @export
importAnnotations <- function(annotFile, 
                              motifsInRanking=NULL,
                              columnsToKeep=NULL)
{
  mAnnot <- data.table::fread(annotFile, 
                          colClasses = setNames("character","source_version"))
  colnames(mAnnot)[which(colnames(mAnnot)=="#motif_id")] <- "motif"
  colnames(mAnnot)[which(colnames(mAnnot)=="gene_name")] <- "TF"
  
  if(!is.null(motifsInRanking))
  {
    nMissingMotifs <- sum(unique(motifsInRanking) %in% mAnnot$motif)
    if(nMissingMotifs>0) 
      warning(nMissingMotifs,
              " of the requested motifs are not in the annotation file.")
    mAnnot <- mAnnot[mAnnot$motif %in% motifsInRanking]
  }
  
  # Re-format annotations
  mAnnot$directAnnotation <- unlist(
    mAnnot[,"description"]=="gene is directly annotated")
  mAnnot$inferred_Orthology <- mAnnot[,"orthologous_gene_name"]!="None"
  mAnnot$inferred_MotifSimil <- mAnnot[,"similar_motif_id"]!="None"
  
  annotationSource <- rep("", nrow(mAnnot))
  annotationSource[mAnnot$directAnnotation] <- "directAnnotation"
  annotationSource[mAnnot$inferred_Orthology] <- "inferredBy_Orthology"
  annotationSource[mAnnot$inferred_MotifSimil] <- "inferredBy_MotifSimilarity"
  annotationSource[mAnnot$inferred_Orthology 
      & mAnnot$inferred_MotifSimil] <- "inferredBy_MotifSimilarity_n_Orthology"
  mAnnot$annotationSource=factor(annotationSource); rm(annotationSource)
  #table(mAnnot$directAnnotation, mAnnot$annotationSource)
  
  selectedColumns <- c("motif", "TF", 
             "directAnnotation", "inferred_Orthology", "inferred_MotifSimil",
             "annotationSource", "description", columnsToKeep)
  mAnnot <- mAnnot[,selectedColumns,with=FALSE]
  data.table::setkeyv(mAnnot, c("motif", "TF"))
  
  attr(mAnnot, "SourceFileName") <- basename(annotFile)
  return(mAnnot)
}

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)

#' @title Add motif logo to RcisTarget results table
#' @description Adds a column containing the logo URL to RcisTarget results
#' table. 
#' @param motifEnrDT Results from RcisTarget (data.table)
#' @param addHTML Whether to add the HTML tag <img> around the URL or not
#' (boolean).
#' @param dbVersion The default value 'v10nr_clust' corresponds to the 
#' latest version of the databases (currently version 10). 
#' For previous databases use 'v8' or 'v9', as appropriate.
#' @param motifCol Name of the column which contains the logo ID.
#' @return Returns the results table with a new column: 'logo'.
#' This column contains either a URL with the logo image, or the HTML code to
#' show the logo [e.g. with datatable()].
#' @seealso \code{vignette("showLogo")} to directly show the table as HTML. 
#' See the package vignette for more examples:
#' \code{vignette("RcisTarget")}
#' @example inst/examples/example_addLogo.R
#' @export
addLogo <- function(motifEnrDT, addHTML=TRUE, dbVersion=NULL, motifCol="motif")
{
  # Depending on whether it is the motif enrichment or annotation file:
  annotationVersion <- attr(motifEnrDT, "annotationVersion")
  if(is.null(annotationVersion)) annotationVersion <- attr(motifEnrDT, "SourceFileName")
  
  if(is.null(annotationVersion))
  {
    warning("There is no annotation version attribute in the input table ",
            "(it has probably been loaded with an older version of the package).",
            "'v9' will be used as it was the old default,",
            "but we recommend to re-load the annotations and/or re-run the enrichment to make sure everything is consistent.")
    dbVersion <- 'v9'
  }

  if(is.null(dbVersion))
  {
    if(grepl('v10|10nr', annotationVersion)) dbVersion <- 'v10nr_clust'
    if(grepl('v8|mc8nr', annotationVersion)) dbVersion <- 'v8'
    if(grepl('v9|mc9nr', annotationVersion)) dbVersion <- 'v9'
  }else{
    dbVersion <- 'v10nr_clust'
  }
  
  isNA <- which(motifEnrDT[[motifCol]]=="")
  logos <- paste("http://motifcollections.aertslab.org/",
                dbVersion,"/logos/",
                motifEnrDT[[motifCol]],".png", sep="")
  
  if(addHTML)
  {
    logos <- paste('<img src="', logos,
                '" height="52" alt="',
                motifEnrDT[[motifCol]], '"></img>', sep="")
  }
  logos[isNA] <- ""
  
  data.table::data.table(logo=logos, motifEnrDT)
}

#' @title Show RcisTarget as HTML
#' @description Shows the results motif enrichment table as an HTML 
#' including the motif logos. Note that Transfac-Pro logos cannot be shown.
#' @param motifEnrDT Results from RcisTarget (data.table)
#' @param motifCol Name of the column which contains the logo ID.
#' @param dbVersion For current databases (version 10) use "v10nr_clust"
#' @param nSignif Number of digits to show in numeric columns.
#' @param colsToShow Columns to show in the HTML 
#' (by default, the list of the enriched genes is hidden)
#' @param options List of options to pass to \code{DT::databable}
#' @param ... Other arguments to pass to \code{DT::databable}
#' @return Returns the DT::datatable() object which can be shown as HTML.
#' @seealso See the package vignette for more examples:
#' \code{vignette("RcisTarget")}
#' @example inst/examples/example_showLogo.R
#' @export
showLogo <- function(motifEnrDT, 
                       motifCol=c("motif", "bestMotif", "MotifID"), dbVersion=NULL,
                       nSignif=3,
                       colsToShow=c(motifEnrichment=c("motifDb", "logo", "NES", "geneSet", "TF_highConf"),
                                    regulonTargets=c("TF", "gene", "nMotifs", "bestMotif", "logo", "NES", "highConfAnnot", "Genie3Weight")),
                       options=list(pageLength=50), 
                       ...)
{
  met <- motifEnrDT
  # Add motif logo
  if(!is.null(motifCol)){
    motifCol <- motifCol[which(motifCol %in% colnames(met))]
    if(length(motifCol) == 1){
      met <- RcisTarget::addLogo(met, motifCol=motifCol, dbVersion=dbVersion, addHTML=TRUE)
      if(!is.null(colsToShow)) colsToShow <- c("logo", colsToShow)
    }else{
      stop("Please indicate the column containing the motif id (argument 'motifCol') or set it to NULL.")
    }
    # TODO 
    met <- met[grep("transfac_pro__", met[[motifCol]], invert = T),]
  }
  
  # For numeric columns, show only the number of significant digits...
  for(i in which(sapply(met, is.numeric))){
    met[[i]] <- signif(met[[i]], nSignif)
  }
  
  # Keep only requested columns
  if(!is.null(colsToShow)) {
    colsToShow <- unique(unname(unlist(colsToShow)))
    colsToShow <- colsToShow[which(colsToShow %in% colnames(met))]
    met <- met[, colsToShow, with=F]
  }
  
  # Show...
  DT::datatable(met, 
                escape=FALSE, filter="top", options=options, ...)
}

#' Documentation for the data

#' @rdname motifAnnotations
#' @name motifAnnotations
#' @aliases motifAnnotations_hgnc motifAnnotations_mgi motifAnnotations_dmel 
#' motifAnnotations_hgnc_v9 motifAnnotations_mgi_v9 motifAnnotations_dmel_v9
#' motifAnnotations_hgnc_v8 motifAnnotations_mgi_v8 motifAnnotations_dmel_v8
#' @title Annotations of Motifs to TFs
#' @description 
#' \itemize{
#' \item{\bold{motifAnnotations_hgnc}: }{Annotations to \bold{HUMAN} transcription factors for 
#'   the rankings using motif collection version 10.
#'   Source: \emph{motifs-v10nr_clust-nr.hgnc-m0.001-o0.0.tbl}}
#'  
#' \item{\bold{motifAnnotations_mgi}: }{Contains the annotations to \bold{MOUSE} transcription factors for 
#' the rankings using motif collection version 10.
#' Source: \emph{motifs-v10nr_clust-nr.mgi-m0.001-o0.0.tbl}}
#' 
#' \item{\bold{motifAnnotations_dmel}: }{Contains the annotations to \bold{FLY} transcription factors for 
#' the rankings using motif collection version 10.
#' Source: \emph{motifs-v10nr_clust-nr.flybase-m0.001-o0.0.tbl}}
#' }
#' \bold{Previous versions}: 
#' 
#' Annotations for motif collection version 9 ('mc9nr').
#' \itemize{
#'     \item{Human: motifAnnotations_hgnc_v9 (\emph{motifs-v9-nr.hgnc-m0.001-o0.0.tbl}})
#'     \item{Mouse: motifAnnotations_mgi_v9 (\emph{motifs-v9-nr.mgi-m0.001-o0.0.tbl}})
#'     \item{Fly: motifAnnotations_dmel_v9 (\emph{motifs-v9-nr.flybase-m0.001-o0.0.tbl}})
#'     }
#'     
#' Annotations for motif collection version 8 ('mc8nr'). 
#' - Deprecated: Will be removed in upcoming versions of the package
#' \itemize{
#'     \item{Fly: motifAnnotations_dmel_v8 (\emph{motifs-v8-nr.flybase-m0.001-o0.0.tbl}})
#'     }
#' 
#' 
#' These objects are meant to be provided to RcisTarget without modification, 
#' but it can also be explored by the user 
#' to obtain further information about the motifs.
#' The original files can be downloaded from \code{https://resources.aertslab.org/cistarget/motif2tf/}
#' Columns:
#' \itemize{
#'  \item{\bold{motif}: }{Motif ID.}
#'  \item{\bold{TF}: }{Transcription factor (or inferred gene).}
#'  \item{\bold{directAnnotation}, \bold{inferred_Orthology}, 
#'        \bold{inferred_MotifSimil}: }
#'     {Boolean values indicating whether the motif is 
#'        annotated to the TF in the source database ("directAnnotation"), 
#'        or whether it was inferred by orthology ("inferred_Orthology") 
#'        or motif similarity ("inferred_MotifSimil").}
#'  \item{\bold{Description}: }{Description of the source of the annotation.}
#'    \item{\bold{annotationSource}: }{
#'      Source of the annotation formatted as factor (e.g. for subsetting). 
#'      Levels: directAnnotation, inferredBy_Orthology, 
#'      inferredBy_MotifSimilarity, inferredBy_MotifSimilarity_n_Orthology.}
#' }
#' @docType data
#' @seealso importAnnotations, RcisTarget
#' @keywords datasets
NULL

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)

#' @title Re-rank RcisTarget ranking
#' @description Re-ranks the genes/regions in the database for each motif. This allows to do motif enrichment over a background.
#' @param rankingsDb Results from RcisTarget (data.table)
#' @param columns Whether to add the HTML tag <img> around the URL or not
#' (boolean).
#' @return Returns a new ranking database with the new ranking values.
#' @seealso See the "background" vignette for more examples:
#' \code{vignette("RcisTarget-withBackground")}
#' @example inst/examples/example_reRank.R
#' @export
reRank <- function(rankingsDb, columns=NULL)
{
  rankingMat <- getRanking(rankingsDb)
  if(!is.null(columns)) rankingMat <- rankingMat[,unique(c(colnames(rankingMat)[1], columns))]
  
  # Re-rank the genes...
  featureNames <- unname(unlist(rankingMat[,1]))
  rankingMat <- t(apply(rankingMat[,-1], 1, rank, ties.method="random"))
  
  mode(rankingMat) <- "integer"
  rankingMat <- tibble::as.tibble(rankingMat)
  rankingMat <- tibble::add_column(rankingMat, features=featureNames, .before = 1)
  
  # Return
  reRanked <- new("rankingRcisTarget",
      rankings=rankingMat,
      colType=rankingsDb@colType,
      rowType=rankingsDb@rowType,
      org=rankingsDb@org,
      genome=rankingsDb@genome,
      nColsInDB=ncol(rankingMat)-1,
      maxRank=Inf,
      description=rankingsDb@description)
  return(reRanked)
}

##################################################
# Setup & previous steps in the workflow:

#### Gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

#### Databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
# motifRankings <- importRankings("hg19-500bp-upstream-7species.mc9nr.feather")
# data("motifAnnotations_hgnc") # human TFs (for motif collection 10)

## For this example we will use a SUBSET of the ranking/motif databases:
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9

### Run RcisTarget
# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)
# Step 2. Select significant motifs, add TF annotation & format as table
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
           motifAnnot=motifAnnotation)

##################################################

##################################################
# (This step: Step 3)
# Identify the genes that have the motif significantly enriched
# (i.e. genes from the gene set in the top of the ranking)
par(mfrow=c(1,2))
motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable,
                                       genesFormat="geneList",
                                       plotCurve=TRUE,
                                       geneSets=geneLists,
                                       rankings=motifRankings,
                                       method="aprox")

#### Exploring the output:
# The object returned is a data.table
# Feel free to convert it to a data.frame:
motifEnrichmentTable_wGenes <- as.data.frame(motifEnrichmentTable_wGenes)

# Enriched genes
enrGenes <- motifEnrichmentTable_wGenes[1,"enrichedGenes"]
enrGenes
strsplit(enrGenes, ";")

# As incidence matrix
motifEnr_wIncidMat <- addSignificantGenes(motifEnrichmentTable,
                geneSets=geneLists, rankings=motifRankings,
                method="aprox",
                genesFormat = "incidMatrix")

motifEnr_wIncidMat <- as.data.frame(motifEnr_wIncidMat)
which(colnames(motifEnr_wIncidMat) == "rankAtMax")

incidMat <- motifEnr_wIncidMat[,8:ncol(motifEnr_wIncidMat)]
rownames(incidMat) <- motifEnr_wIncidMat[,"motif"]
incidMat <- incidMat[, colSums(incidMat)>0, drop=FALSE]

# Plot as network
par(mfrow=c(1,1))
library(igraph)
plot(graph.incidence(incidMat))

###############################################################
# Alternative method: getSignificantGenes()
selectedMotif <- rownames(incidMat)
onlyGenes <- getSignificantGenes(geneSet=geneLists$hypoxia,
                            signifRankingNames=selectedMotif,
                            genesFormat="incidMatrix",
                            plotCurve=TRUE,
                            rankings=motifRankings,
                            method="aprox")

# #############################################################################
# Calculates gene enrichment: i-CisTarget version
# Arguments should be kept in the same order as .calcEnr_Aprox
.calcEnr_iCisTarget <- function(gsRankings, maxRank,
                                signifRankingNames, plotCurve, nCores, nMean)
{
  # nMean: ignored

  # Calculate RCC for all motifs
  rccs <- .calcRCC(gsRankings, maxRank, nCores)

  # Estimate mean and mean+2sd at each rank
  rccMean <- apply(rccs, 1, mean)
  rccM2sd <- rccMean + (2*apply(rccs, 1, sd))
  # TO DO: Save/return somehow?

  # Max enrichment for the selected rankings[,srName]
  maxEnr <- sapply(signifRankingNames, function(sr) {
    x <- min(which.max(rccs[,sr]-rccM2sd))
    c(x=x, y=unname(rccs[x,sr]))
  })
  colnames(maxEnr) <- signifRankingNames

  # Plot
  if(plotCurve)
  {
    na <- sapply(colnames(maxEnr), function(srName) {
      .plotRCC(rccMean, rccM2sd, srName, maxEnr[,srName], rccs[,srName])
    })
  }
  return(maxEnr)
}
# 50-110 secs

##############################################################################
# Calculates gene enrichment: Aproximated/faster version
# Arguments should be kept in the same order as .calcEnr_iCisTarget
.calcEnr_Aprox <- function(gsRankings, maxRank,
                           signifRankingNames, plotCurve, nCores, nMean)
{
  # Calculate aproximated-RCC across all motifs at each rank position
  # maxRank <- min(c(maxRank, nrow(gsRankings)))  # Correct??
  maxRankExtra <- maxRank+nMean
  gsRankings.asMat <- as.matrix(gsRankings) # Much faster!
  gsRankings.asMat[gsRankings.asMat>maxRankExtra] <- NA
  globalMat <- matrix(0, nrow=max(nrow(gsRankings),max(gsRankings.asMat, na.rm=T)), ncol=maxRankExtra) #  nrow=nrow(gsRankings): can be out of range, add extra rows and subset at the end
  
  # x <- x[seq_len(min(length(x), nrow(globalMat)))] # or: # if(nrow(globalMat) < length(x)) x <- x[seq_len(nrow(globalMat))] # cannot be in the loop... too slow!
  for(i in 1:nrow(gsRankings)) # (TO DO: Paralellize?)
  {
    x <- sort(gsRankings.asMat[i,])
    if(length(x) > 0){
      coords <- cbind(y=seq_along(x), x)
      globalMat[coords] <- globalMat[coords]+1
      
      # for(y in seq_along(x)) globalMat[y,x[y]] <- globalMat[y,x[y]]+1
    }
  }
  globalMat <- globalMat[1:nrow(gsRankings), 1:maxRankExtra] # 
  
  # Estimate mean and mean+2sd at each rank
  rccStatsRaw <- apply(globalMat, 2, function(x){
    tmp <- x
    if(sum(x)>0) tmp <- rep(seq_along(x), x)
    rccMean <- mean(tmp)
    rccSd <- sd(tmp)
    c(mean=rccMean, sd=rccSd)
  })
  # Remove NAs (assign left value)
  nas <- which(is.na(rccStatsRaw), arr.ind=TRUE)
  if(any(nas[,2] == 1)) {  # First value cannot be assigned to left
    rccStatsRaw[nas[which(nas[,2]==1), ]] <- 0
    nas <- nas[which(nas[,2]!=1), , drop=FALSE]
  }
  if(nrow(nas)>0){
    for(i in seq_len(nrow(nas)))
    {
      x <- nas[i,]
      rccStatsRaw[x[1], x[2]] <- rccStatsRaw[x[1], x[2]-1]
    }
  }


  # Reduce noise in the stats with the rolling mean
  rccStats <- t(apply(rccStatsRaw, 1,
                      function(x)
                        c(x[1:5],   # Correct??
                          zoo::rollmean(x, nMean, align="center",
                                        fill="extend"))))[,1:(maxRank-1)]
  rccM2sd <- rccStats["mean",] + (2*rccStats["sd",])
  rccMean <- rccStats["mean",]
  rm(rccStats); rm(globalMat)


  # Calculate real RCC & max enrichment for selected rankings
  rccs <- .calcRCC(gsRankings[signifRankingNames,,drop=FALSE], maxRank, nCores)
  maxEnr <- sapply(signifRankingNames, function(sr) {
    x <- min(which.max(rccs[,sr]-rccM2sd))
    c(x=x, y=unname(rccs[x,sr]))
  })

  # Plot
  if(plotCurve)
  {
    # Global estimation plot
    plot(rccStatsRaw["mean",]+2*rccStatsRaw["sd",],
         type="l", col="lightgreen",
         xlab="Rank", ylab="#genes recovered",
         main="Global mean and SD estimation", 
         xlim=c(0,maxRank))
    lines(rccStatsRaw["mean",],type="l", col="pink")
    lines(rccMean, col="red")
    lines(rccM2sd, col="darkgreen")

    # RCC for each significant ranking
    na <- sapply(colnames(maxEnr), function(srName) {
      .plotRCC(rccMean, rccM2sd, srName, maxEnr[,srName], rccs[,srName])
    })
  }
  return(maxEnr)
}

###############################################################################
# Aux functions

# Calculates RCC (of the gene-set) ONE RANKING
.calcRCC.oneRanking <- function(x, maxRank)
{
  x <- unlist(x)
  x <- sort(x[x<maxRank])

  curranking <- c(x, maxRank)
  unlist(mapply(rep, seq_along(curranking)-1,
                c(curranking[1], diff(curranking))))[-1]
}

# Apply .calcRCC.oneRanking on all rankings (= each column)
.calcRCC <- function(gsRankings, maxRank, nCores)
{
  if(nCores==1)
  {
    rccs <- apply(gsRankings, 1, .calcRCC.oneRanking, maxRank)
  }else
  {
    # Split rankings into 10 groups and run in parallel
    doParallel::registerDoParallel()
    options(cores=nCores)

    rowsNam <- rownames(gsRankings)
    suppressWarnings(
      rowNamsGroups <- split(rowsNam, (seq_along(rowsNam)) %% nCores)) 
        # Expected warning: Not multiple
    
    # rccs <- foreach(colsGr=colsNamsGroups, .combine="cbind") %do%
    rowsGr <- NULL
    rccs <- foreach::"%do%"(foreach::foreach(rowsGr=rowNamsGroups,
                                             .combine="cbind"),
    {
      apply(gsRankings[rowsGr,, drop=FALSE],1, .calcRCC.oneRanking, maxRank)
    })
  }
  return(rccs)
}

library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly


genes <- colnames(getRanking(motifRankings))[10:20]
reRank(motifRankings, columns=genes)

#' @title Class to store the AUC scores for RcisTarget.
#' @aliases getAUC
#' @description
#'
#' Contains the AUC scores for each gene- or region-set.
#' They can be accessed through \code{getAUC()} and the regular methods
#' (i.e. nrow, rownames... ) available for SummarizedExperiment objects.
#'
#' @param object Results from \code{calcAUC}.
#' @return
#' \itemize{
#' \item show: Prints a summary of the object
#' \item getAUC: Returns the matrix containing the AUC scores
#' }
#' @method show aucScores
#' @method getAUC aucScores
#' @example inst/examples/example_aucScores_class.R
#' @importClassesFrom SummarizedExperiment SummarizedExperiment
#' @importMethodsFrom SummarizedExperiment assay assays assayNames
#' @importFrom R.utils capitalize
#' @importFrom utils head
#' @rdname aucScores-class
#' @export aucScores
aucScores <- setClass("aucScores",
  contains="SummarizedExperiment",
  representation=representation(
    org = "character", # human/mouse
    genome = "character", # hg19, mm9 ...
    description = "character" # Other info, shown with "show"
  )
)

#' @rdname aucScores-class
#' @aliases show,aucScores-method
setMethod("show",
  signature="aucScores",
  definition = function(object) {
    message <- paste(R.utils::capitalize(assayNames(object)), " for ",
                 nrow(object)," ", names(dimnames(assay(object)))[1],
                 "s and ",
                 ncol(object)," ", names(dimnames(assay(object)))[2],
                 "s.\n", sep="")

    if(object@org!="")
      message <- paste(message, "  Organism: ", object@org,
                       " (", object@genome,")","\n  ",
                        object@description,"\n", sep="")

    message <- paste(message,
                       "\nAUC matrix preview:\n", sep="")
    cat(message)
    subsetToPrint <- head(assay(object)[,seq_len(min(5, ncol(object))),
                                        drop=FALSE])
    names(dimnames(subsetToPrint)) <- NULL
    show(subsetToPrint)

  }
)
##### Access the matrix:
#' @importFrom AUCell getAUC
#' @name getAUC
#' @rdname aucScores-class
#' @aliases getAUC,aucScores-method
#' @exportMethod getAUC
setMethod("getAUC",
  signature="aucScores",
  definition = function(object) {
    if("AUC" %in% assayNames(object)) {
      assays(object)[["AUC"]]
    }else{
      stop("This object does not contain an AUC matrix.")
    }
  }
)

##################################################
# Setup & previous steps in the workflow:

#### Gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

#### Databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
# motifRankings <- importRankings("~/databases/hg38_10kbp_up_10kbp_down_full_tx_v10_clust.genes_vs_motifs.rankings.feather")

## For this example we will use a SUBSET of the ranking/motif databases:
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly

### Run RcisTarget
# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)

##################################################

#Exploring the output:
motifs_AUC

class(motifs_AUC)

# Extracting the AUC matrix:
getAUC(motifs_AUC)[,1:5]

# Subsetting and regular manipulation methods are also available:
motifs_AUC[1,]
motifs_AUC[,3:4]

dim(motifs_AUC)
nrow(motifs_AUC)
ncol(motifs_AUC)
colnames(motifs_AUC)
rownames(motifs_AUC)

# RcisTarget workflow for advanced users:
# Running the workflow steps individually

\dontrun{
  
##################################################
#### Load your gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
               "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])
  
#### Load databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
motifRankings <- importRankings("~/databases/hg38_10kbp_up_10kbp_down_full_tx_v10_clust.genes_vs_motifs.rankings.feather")

## Motif - TF annotation:
data("motifAnnotations_hgnc") # human TFs (for motif collection 10)
##################################################

#### Run RcisTarget

# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)

# Step 2. Select significant motifs, add TF annotation & format as table
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                         motifAnnot=motifAnnotations)

# Step 3 (optional). Identify genes that have the motif significantly enriched
# (i.e. genes from the gene set in the top of the ranking)
motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable,
                                                   geneSets=geneLists,
                                                   rankings=motifRankings,
                                                   method="aprox")

}

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)

#' @importFrom stats sd setNames
#'
#' @title Add motif annotation
#' @description Select significant motifs and/or annotate motifs to
#' genes or transcription factors.
#' The motifs are considered significantly enriched if they pass the the
#' Normalized Enrichment Score (NES) threshold.
#' @param auc Output from calcAUC.
#' @param nesThreshold Numeric. NES threshold to calculate the motif significant
#' (3.0 by default). The NES is calculated -for each motif- based on the AUC
#' distribution of all the motifs for the gene-set [(x-mean)/sd].
#' @param digits Integer. Number of digits for the AUC and NES in the
#' output table.
#' @param motifAnnot Motif annotation database containing the 
#' annotations of the motif to transcription factors.
#' The names should match the ranking column names.
#' @param motifAnnot_highConfCat Categories considered as source for 
#' 'high confidence' annotations. By default, 
#' "directAnnotation" (annotated in the source database), and 
#' "inferredBy_Orthology" (the motif is annotated to an homologous/ortologous 
#' gene).
#' @param motifAnnot_lowConfCat Categories considered 
#' 'lower confidence' source for annotations. By default, the annotations 
#' inferred based on motif similarity ("inferredBy_MotifSimilarity", 
#' "inferredBy_MotifSimilarity_n_Orthology").
#' @param idColumn Annotation column containing the ID (e.g. motif, accession)
#' @param highlightTFs Character. If a list of transcription factors is
#' provided, the column TFinDB in the otuput table will indicate whether any
#' of those TFs are included within the 'high-confidence' annotation 
#' (two asterisks, **)
#' or 'low-confidence' annotation (one asterisk, *) of the motif.
#' The vector can be named to indicate which TF to highlight for each gene-set.
#' Otherwise, all TFs will be used for all geneSets.
#' @param keepAnnotationCategory Include annotation type in the TF information?
#' @return \code{\link[data.table]{data.table}} with the folowing columns:
#' \itemize{
#' \item geneSet: Name of the gene set
#' \item motif: ID of the motif
#' (colnames of the ranking, it might be other kind of feature)
#' \item NES: Normalized enrichment score of the motif in the gene-set
#' \item AUC: Area Under the Curve (used to calculate the NES)
#' \item TFinDB: Indicates whether the highlightedTFs are included within the
#' high-confidence annotation (two asterisks, **)
#' or lower-confidence annotation (one asterisk, *)
#' \item TF_highConf: Transcription factors annotated to the motif 
#' based on high-confidence annotations.
#' \item TF_lowConf: Transcription factors annotated to the motif according to
#' based on lower-confidence annotations.
#' }
#' @seealso Next step in the workflow: \code{\link{addSignificantGenes}}.
#'
#' Previous step in the workflow: \code{\link{calcAUC}}.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("RcisTarget")}
#' @example inst/examples/example_addMotifAnnotation.R
#' @export
addMotifAnnotation <- function(auc, nesThreshold=3.0, digits=3,
       motifAnnot=NULL, 
       motifAnnot_highConfCat=c("directAnnotation", "inferredBy_Orthology"), 
       motifAnnot_lowConfCat=c("inferredBy_MotifSimilarity", 
                               "inferredBy_MotifSimilarity_n_Orthology"), 
       idColumn="motif",
       highlightTFs=NULL,
       keepAnnotationCategory=TRUE)
{
  aucDescr <- unname(auc@description)
  auc <- getAUC(auc)
  #### Check inputs
  if(!is.null(highlightTFs))
  {
    if(is.null(motifAnnot))
      stop("To hightlight TFs, please provide a motif-TF annotation.")
    if(is.null(names(highlightTFs))) {
      warning("The input TFs are not named, ",
              "all TFs will be used with all Gene Sets.")
      highlightTFs <- setNames(rep(list(highlightTFs), nrow(auc)),
                               rownames(auc))
    }
    
    if(!all(names(highlightTFs) %in% rownames(auc))) warning("TFs 1")
    if(!all(rownames(auc) %in% names(highlightTFs))) warning("TFs 2")
  }
  
  if(!is.null(motifAnnot))
  {
    if(!is.data.table(motifAnnot))
      stop("motifAnnot should be a data.table")
    # if(!is.null(motifAnnot_highConfCat) && 
    #    any(!motifAnnot_highConfCat %in% levels(motifAnnot$annotationSource)))
    #   warning("'motifAnnot_highConfCat' 
    #        should be a value in the column 'annotationSource'.") 
    # 
    # if(!is.null(motifAnnot_lowConfCat) && 
    #    any(!motifAnnot_lowConfCat %in% levels(motifAnnot$annotationSource)))
    #   warning("'motifAnnot_lowConfCat' 
    #        should be a value in the column 'annotationSource'.") 
    
    commonCat <- intersect(motifAnnot_highConfCat, motifAnnot_lowConfCat)
    if(length(commonCat)>0)
      warning("The following annotation types are both in", 
              "'motifAnnot_highConfCat' and 'motifAnnot_lowConfCat': ", commonCat)
  }
  
  #### Runs "auc.asTable" on each signature/geneset
  applyFun <- lapply
  if((nrow(auc)>4) && ("BiocParallel" %in% installed.packages())) 
  {
    applyFun <- BiocParallel::bplapply
    message("Using BiocParallel...")
  }
  
  ret <- applyFun(rownames(auc), function(geneSet) {
    tfs <- highlightTFs[[geneSet]]
    aucTable <- .auc.asTable(auc[geneSet,],
                             nesThreshold=nesThreshold, digits=digits, idColumn=idColumn)
    if(nrow(aucTable)>0)
    {
      aucTable <- .addTfs(aucTable,
                          motifAnnot=motifAnnot,
                          TFs=tfs, 
                          motifAnnot_highConfCat=motifAnnot_highConfCat,
                          motifAnnot_lowConfCat=motifAnnot_lowConfCat,
                          idColumn=idColumn,
                          keepAnnotationCategory=keepAnnotationCategory)
      aucTable <- data.table::data.table(geneSet=geneSet, aucTable)
    }else{
      aucTable <- NULL
    }
    aucTable
  })
  
  ## Merge the results from each signature/geneSet/regionSet into a single dt
  # ret <- do.call(rbind, unname(ret))  # Slower?
  # library(data.table)
  ret <- data.table::rbindlist(ret)
  attr(ret, "annotationVersion") <- aucDescr
  
  if(nrow(ret)>0)
    colnames(ret)[which(colnames(ret) == "ranking")] <- "motif"
  return(ret)
}


############ PRIVATE
.calcNES <- function(AUC)
{
  meanAUC <- mean(AUC)
  sdAUC <- sd(AUC)
  
  # NES = (AUC-mean)/sd
  NES <- vapply(AUC, function(x) (x-meanAUC)/sdAUC,
                FUN.VALUE=numeric(1))
  return(NES)
}

.auc.asTable <- function(auc, nesThreshold=3.0, digits=3, idColumn="motif")
{
  nes <- .calcNES(auc)
  nes <- sort(nes, decreasing=TRUE)
  
  signifRankings <- names(nes)[which(nes >= nesThreshold)]
  aucTable <- data.table::data.table(motif=signifRankings,
                                     NES=signif(nes[signifRankings], digits=digits),
                                     AUC=signif(auc[signifRankings],digits=digits))
  colnames(aucTable)[1] <- idColumn
  aucTable
}

.addTfs <- function(aucTable,
                    motifAnnot=NULL,
                    TFs=NULL,
                    motifAnnot_highConfCat=NULL,
                    motifAnnot_lowConfCat=NULL,
                    idColumn="motif",
                    keepAnnotationCategory=keepAnnotationCategory)
{
  if(!is.null(TFs))
  {
    aucTable <- data.table::data.table(aucTable,
                                 highlightedTFs=paste(TFs, collapse=", ") ,
                                 TFinDB="")
    
    if(!is.null(motifAnnot)) {
      motifAnnot_subset <- motifAnnot[(motifAnnot[[idColumn]] %in% aucTable[[idColumn]]) 
                                      & (motifAnnot$TF %in% TFs), ][,c(idColumn, "TF", "annotationSource"),with=F]
      motifAnnot_subset <- split(motifAnnot_subset, motifAnnot_subset[[idColumn]])
      for(motifName in names(motifAnnot_subset))
      {
        if(any(as.character(motifAnnot_subset[[motifName]]$annotationSource) 
               %in% motifAnnot_lowConfCat))
          aucTable[aucTable[[idColumn]]==motifName,"TFinDB"] <- "*"
        
        # overrides lowConf
        if(any(as.character(motifAnnot_subset[[motifName]]$annotationSource) 
               %in% motifAnnot_highConfCat))
          aucTable[aucTable[[idColumn]]==motifName,"TFinDB"] <- "**"
      }
    }
  }
  
  if(!is.null(motifAnnot))
  {
    if(!is.null(motifAnnot_highConfCat))
    {
      TF_highConf <- .formatTfs(motifs=aucTable[[idColumn]], 
                                motifAnnot=motifAnnot,
                                annotCats=motifAnnot_highConfCat,
                                idColumn=idColumn,
                                keepAnnotationCategory=keepAnnotationCategory)
      
      aucTable <- data.table::data.table(aucTable, TF_highConf=TF_highConf)
    }
    
    if(!is.null(motifAnnot_lowConfCat))
    {
      TF_lowConf <- .formatTfs(motifs=aucTable[[idColumn]], 
                               motifAnnot=motifAnnot,
                               annotCats=motifAnnot_lowConfCat,
                               idColumn=idColumn, 
                               keepAnnotationCategory=keepAnnotationCategory)
      
      aucTable <- data.table::data.table(aucTable, TF_lowConf=TF_lowConf)
    }
  }
  
  aucTable
}


## 26 apr 2019
# Replaced input: aucTable by motifs. In calls:  .formatTfs(motifs=aucTable[[idColumn]]
# aucTable$motif --> motifs
# nrow(aucTable) --> length(motifs)
.formatTfs <- function(motifs, motifAnnot, annotCats, idColumn, keepAnnotationCategory)
{
  motifAnnot_subset <- motifAnnot[motifAnnot$annotationSource %in% annotCats, ] 
  motifAnnot_subset <- motifAnnot_subset[motifAnnot_subset[[idColumn]] %in% motifs, ] 
  if(keepAnnotationCategory)
  {
    motifAnnot_Cats <- vapply(split(motifAnnot_subset, motifAnnot_subset[[idColumn]]), 
                              function(mat){
                                mat <- split(mat$TF, factor(mat$annotationSource))
                                tfsByCat <- vapply(names(mat),
                                                   function(x) paste(paste(unlist(mat[[x]]),
                                                                           collapse="; "),
                                                                     " (",x,"). ",
                                                                     sep=""), "")
                                paste(tfsByCat, collapse="")
                              }, FUN.VALUE="")
  }else{
    motifAnnot_Cats <- vapply(split(motifAnnot_subset, motifAnnot_subset[[idColumn]]), 
                              function(mat){
                                paste(unique(unlist(mat$TF)), collapse="; ")
                              }, FUN.VALUE="")
  }
   
  ret <- setNames(rep("", length(motifs)), motifs)
  ret[names(motifAnnot_Cats)] <- motifAnnot_Cats
  return(ret)
}

#' @title Get motif annotation
#' @description Get the genes/transcription factors annotated to the given motifs

#' @param motifs Motif IDs 
#' @param motifAnnot Motif annotation database containing the 
#' annotations of the motif to genes or transcription factors.
#' @param annotCats Annotation categories to be considered:  
#' "directAnnotation" (annotated in the source database),  
#' "inferredBy_Orthology" (the motif is annotated to an homologous/ortologous 
#' gene), or inferred based on motif similarity ("inferredBy_MotifSimilarity", 
#' "inferredBy_MotifSimilarity_n_Orthology").
#' @param idColumn Annotation column containing the ID (e.g. motif, accession)
#' @param returnFormat Determines the output format. Choose one of the following values:
#' @param keepAnnotationCategory Include annotation type in the TF information?
#' \itemize{
#' \item \code{asCharacter}: Named vector with the genes or TFs annotated to the given motifs (in the same order, including empty and duplicated values).
#' \item \code{subset}: Subset of the annotation table (list split by motif)
#' \item \code{list}: List of TF names (unique values), duplicated motifs or motifs without annotation are not returned.
#' }
#' @return See argument \code{returnFormat}
#' @seealso \code{\link{addMotifAnnotation}} add the annotation directly to the motif enrichment results.
#' 
#' See the package vignette for examples and more details:
#' \code{vignette("RcisTarget")}
#' @example inst/examples/example_addMotifAnnotation.R
#' @export
getMotifAnnotation <- function(motifs, 
                               motifAnnot, 
                               annotCats=c("directAnnotation",
                                           "inferredBy_MotifSimilarity",
                                           "inferredBy_Orthology",
                                           "inferredBy_MotifSimilarity_n_Orthology"),
                               idColumn="motif",
                               returnFormat=c("asCharacter","subset","list")[1],
                               keepAnnotationCategory=TRUE)
{
  ## Check inputs:
  returnFormat <- tolower(returnFormat)
  if(!returnFormat %in% c("ascharacter","subset","list")) stop("returnFormat should be eihter 'asCharacter', 'subset', or 'list'.")
  if(length(returnFormat)>1) stop("Please, choose ONE returnFormat.")
  
  ## Run:
  if(returnFormat=="ascharacter"){
    ret <- .formatTfs(motifs=motifs, 
                      motifAnnot=motifAnnot,
                      annotCats=annotCats,
                      idColumn=idColumn,
                      keepAnnotationCategory=keepAnnotationCategory) 
  }else{
    ret <- .getTfs(motifs=motifs, 
                   motifAnnot=motifAnnot,
                   annotCats=annotCats,
                   idColumn=idColumn,
                   returnFormat=returnFormat) 
  }
  return(ret)
}

.getTfs <- function(motifs, motifAnnot, annotCats, idColumn, returnFormat)
{
  motifAnnot_subset <- motifAnnot[motifAnnot$annotationSource %in% annotCats, ] 
  motifAnnot_subset <- motifAnnot_subset[motifAnnot_subset[[idColumn]] %in% motifs, ] 
  # motifAnnot_subset <- split(motifAnnot_subset[,c("TF", "directAnnotation", "inferred_Orthology", "inferred_MotifSimil","annotationSource")], motifAnnot_subset[[idColumn]])
  motifAnnot_subset <- split(motifAnnot_subset, motifAnnot_subset[[idColumn]])
  
  ret <- motifAnnot_subset # returnFormat=="subset"
  
  if(returnFormat=="list")
    ret <- lapply(ret, function(x) sort(unique(x[["TF"]])))
  
  return(ret)
}

##################################################
# Setup & previous steps in the workflow:

#### Gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

#### Databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
# motifRankings <- importRankings("~/databases/hg38_10kbp_up_10kbp_down_full_tx_v10_clust.genes_vs_motifs.rankings.feather")
# data("motifAnnotations_hgnc") # human TFs (for motif collection 10)

## For this example we will use a SUBSET of the ranking/motif databases:
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9

### Run RcisTarget
# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)

##################################################

### (This step: Step 2)
# Before starting: Setup the paralell computation
library(BiocParallel); register(MulticoreParam(workers = 2)) 
# Select significant motifs, add TF annotation & format as table
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                                           motifAnnot=motifAnnotation)

# Alternative: Modifying some options
motifEnrichment_wIndirect <- addMotifAnnotation(motifs_AUC, nesThreshold=2, 
        motifAnnot=motifAnnotation,
        highlightTFs = "HIF1A", 
        motifAnnot_highConfCat=c("directAnnotation"), 
        motifAnnot_lowConfCat=c("inferredBy_MotifSimilarity",
                                "inferredBy_MotifSimilarity_n_Orthology",
                                "inferredBy_Orthology"),
        digits=3)

# Getting TFs for a given TF:
motifs <- motifEnrichmentTable$motif[1:3]

getMotifAnnotation(motifs, motifAnnot=motifAnnotation)
getMotifAnnotation(motifs, motifAnnot=motifAnnotation, returnFormat="list")

### Exploring the output:
# Number of enriched motifs (Over the given NES threshold)
nrow(motifEnrichmentTable)

# Interactive exploration
motifEnrichmentTable <- addLogo(motifEnrichmentTable)
DT::datatable(motifEnrichmentTable, filter="top", escape=FALSE,
              options=list(pageLength=50))
# Note: If using the fake database, the results of this analysis are meaningless

# The object returned is a data.table (for faster computation),
# which has a diferent syntax from the standard data.frame or matrix
# Feel free to convert it to a data.frame (as.data.frame())
motifEnrichmentTable[,1:6]


##################################################
# Next step (step 3, optional):
\dontrun{
  motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable,
                                                     geneSets=geneLists,
                                                     rankings=motifRankings,
                                                     method="aprox")
}

#' @rawNamespace import(GSEABase, except = c(union, intersect, setdiff))
#' @importFrom methods new
#'
#' @title Calculate AUC
#' @description Calculates the Area Under the Curve (AUC) of each gene-set
#' for each motif ranking.
#' This measure is used in the following steps to identify the DNA motifs
#' that are significantly over-represented in the gene-set.
#' @param geneSets List of gene-sets to analyze.
#' The gene-sets should be provided as \code{\link{GeneSet}},
#' \code{\link{GeneSetCollection}} or character list (see examples).
#' @param rankings 'Motif rankings' database for the required organism and
#' search-space (i.e. 10kbp around- or 500bp upstream the TSS).
#' These objects are provided in separate files, 
#' which can be imported with \code{importRankings()}:
#' \itemize{
#' \item \url{http://pyscenic.aertslab.org/databases/mm9-500bp-upstream-7species.mc9nr.feather}[mm9-500bp-upstream-7species.mc9nr] (Mouse, 500bp)
#' \item \url{http://pyscenic.aertslab.org/databases/mm9-tss-centered-10kb-7species.mc9nr.feather}[mm9-tss-centered-10kb-7species.mc9nr] (Mouse, 10kbp)
#' \item \url{http://pyscenic.aertslab.org/databases/hg19-500bp-upstream-7species.mc9nr.feather}[hg19-500bp-upstream-7species.mc9nr] (Human, 500bp)
#' \item \url{http://pyscenic.aertslab.org/databases/hg19-tss-centered-10kb-7species.mc9nr.feather}[hg19-tss-centered-10kb-7species.mc9nr] (Human, 10kbp)
#' \item -Coming soon- (Fly)
#' }
#' See \code{vignette("RcisTarget")} for an exhaustive list of databases.
#' 
#' Since the normalized enrichment score (NES) of the motif
#' depends on the total number of motifs in the database,
#' we highly recommend to use the full version of the databases (20k motifs).
#' A smaller version of the human databases,
#' containing only the 4.6k motifs from cisbp,
#' are available in Bioconductor:
#' \itemize{
#' \item RcisTarget.hg19.motifDBs.cisbpOnly.500bp (Human)
#' }
#' @param nCores Number of cores to use for computation.
#' Note: In general, using a higher number of cores (e.g. processes)
#' decreases overall running time.
#' However, it also deppends on the available memory and overall system load.
#' Setting nCores too high might also decrease performance.
#' @param aucMaxRank Threshold to calculate the AUC.
#' In a simplified way, the AUC value represents the fraction of genes,
#' within the top X genes in the ranking, that are included in the signature.
#' The parameter 'aucMaxRank' allows to modify the number of genes
#' (maximum ranking) that is used to perform this computation.
#' By default it is set to 5\% of the total number of genes in the rankings.
#' Common values range from 1 to 10\%.
#' See \code{vignette("RcisTarget")} for examples and more details.
#' @param verbose Should the function show progress messages? (TRUE / FALSE)
#' @return \code{\link{aucScores}} of gene-sets (columns) by motifs (rows)
#' with the value of AUC for each pair as content.
#' @seealso Next step in the workflow: \code{\link{addMotifAnnotation}}.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("RcisTarget")}
#' @example inst/examples/example_workflow.R
#' @rdname calcAUC
#' @export
setGeneric("calcAUC", signature="geneSets",
  function(geneSets, rankings, nCores=1,
      aucMaxRank=0.03*getNumColsInDB(rankings),
      verbose=TRUE)
  {
    standardGeneric("calcAUC")
  })

#' @rdname calcAUC
#' @aliases calcAUC,list-method
setMethod("calcAUC", "list",
  function(geneSets, rankings, nCores=1,
           aucMaxRank=0.03*getNumColsInDB(rankings), 
           verbose=TRUE)
  {
    .RcisTarget_calcAUC(geneSets=geneSets,
                        rankings=rankings,
                        nCores=nCores,
                        aucMaxRank=aucMaxRank,
                        # rnkIndexCol=rnkIndexCol,
                        verbose=verbose)
  })

#' @rdname calcAUC
#' @aliases calcAUC,character-method
setMethod("calcAUC", "character",
  function(geneSets, rankings, nCores=1,
           aucMaxRank=0.03*getNumColsInDB(rankings), 
           verbose=TRUE)
  {
    geneSets <- list(geneSet=geneSets)

    .RcisTarget_calcAUC(geneSets=geneSets,
                        rankings=rankings,
                        nCores=nCores,
                        aucMaxRank=aucMaxRank,
                        # rnkIndexCol=rnkIndexCol,
                        verbose=verbose)
  })

#' @rdname calcAUC
#' @aliases calcAUC,GeneSet-method
setMethod("calcAUC", "GeneSet",
  function(geneSets, rankings, nCores=1,
           aucMaxRank=0.03*getNumColsInDB(rankings), 
           verbose=TRUE)
  {
    geneSets <- setNames(list(GSEABase::geneIds(geneSets)),
                         GSEABase::setName(geneSets))

    .RcisTarget_calcAUC(geneSets=geneSets,
                        rankings=rankings,
                        nCores=nCores,
                        aucMaxRank=aucMaxRank,
                        # rnkIndexCol=rnkIndexCol,
                        verbose=verbose)
  })

#' @rdname calcAUC
#' @aliases calcAUC,GeneSetCollection-method
setMethod("calcAUC", "GeneSetCollection",
  function(geneSets, rankings, nCores=1,
           aucMaxRank=0.03*getNumColsInDB(rankings), 
           verbose=TRUE)
  {
    geneSets <- GSEABase::geneIds(geneSets)

    .RcisTarget_calcAUC(geneSets=geneSets,
                        rankings=rankings,
                        nCores=nCores,
                        aucMaxRank=aucMaxRank,
                        # rnkIndexCol=rnkIndexCol,
                        verbose=verbose)
  })

.RcisTarget_calcAUC <- function(geneSets, rankings, nCores=1,
                                aucMaxRank=0.03*getNumColsInDB(rankings), 
                                verbose=TRUE)
{
  # Check the gene sets
  if(!is.list(geneSets))
    stop("geneSets should be a named list.")
  if(is.null(names(geneSets)))
    stop("geneSets should be a named list.")
  if(nCores > length(geneSets))
    nCores <- length(geneSets) # No point in using more...
  
  # Check the rankings
  if(! "rankingRcisTarget" %in% class(rankings))
    stop("The rankings should be of class rankingRcisTarget.")
  
  maxRankInDb <- min(c(getMaxRank(rankings), getNumColsInDB(rankings)))
  if(maxRankInDb < Inf)
  {
    if(aucMaxRank > maxRankInDb)
      stop("aucMaxRank (", aucMaxRank,
        ") should not be bigger than the maximum ranking available ",
        "in the database (", maxRankInDb,")")
  }
  if(aucMaxRank <=0) stop("aucMaxRank should be a positive value.")

  rankingsInfo <- c(org="", genome="", description="")
  if(isS4(rankings)) {
    rankingsInfo <- c(org=rankings@org,
                      genome=rankings@genome,
                      description=rankings@description)
    rankings <- getRanking(rankings)
    
    # # could be added as argument...
    # if(!rnkIndexCol %in% colnames(rankings)) 
    #   stop(paste0("No feature names in the ranking (column '",rnkIndexCol,"')"))
  }
  if(!is.data.frame(rankings))
    stop("Rankings does not have the right format.")

  # Check if the genes are included in the rankings
  allGenes <- unique(unlist(geneSets))
  if(sum(allGenes %in% colnames(rankings))/length(allGenes) < .80)
    stop("Fewer than 80% of the genes/features in the gene-sets ",
     "are included in the rankings.",
     "Check wether the IDs in the 'rankings' (columns) and 'geneSets' match.")


  ######################################################################
  #### 1. Calculate the AUC for each gene set
  if(nCores==1)
  {
    gSetName <- NULL
    aucMatrix <- vapply(names(geneSets), function(gSetName)
      .AUC.geneSet(geneSet=geneSets[[gSetName]],
                   rankings=rankings[,-1], # featureName
                   aucMaxRank=aucMaxRank,
                   gSetName=gSetName),
      FUN.VALUE=numeric(nrow(rankings)+2))
    aucMatrix <- t(aucMatrix)
    colnames(aucMatrix)[1:(ncol(aucMatrix)-2)] <- as.character(unlist(rankings[,1]))
  }else
  {
    # Run each geneSet in parallel
    doParallel::registerDoParallel()
    options(cores=nCores)

    if(verbose)
      message("Using ", foreach::getDoParWorkers(), " cores.")

    aucMatrix <- tryCatch({
      gSetName <- NULL
      "%dopar%"<- foreach::"%dopar%"
      aucList <- foreach::"%dopar%"(foreach::foreach(gSetName=names(geneSets)),
                                    {
                                      setNames(list(.AUC.geneSet(geneSet=geneSets[[gSetName]],
                                                                 rankings=rankings[,-1],  # featureName
                                                                 aucMaxRank=aucMaxRank,
                                                                 gSetName=gSetName)), gSetName)
                                    })
      aucList <- unlist(aucList, recursive = FALSE)[names(geneSets)]
      aucMat <- do.call(rbind, aucList)
      colnames(aucMat)[1:(ncol(aucMat)-2)] <- as.character(unlist(rankings[,1]))
      aucMat
    }, 
    error = function(e) {
      warning("\n\nSomething was wrong when calculating the motif enrichment.",
              " A temporary file has been saved as 'error_rcisTarget.RData' for debugging.\n\n", immediate. = TRUE)
      error_rcisTarget <- list(geneSets=geneSets, aucMaxRank=aucMaxRank, aucList=aucList)
      save(error_rcisTarget, file="error_rcisTarget.RData")
      stop(e)
    }
    )
  }

  ######################################################################
  ##### Messages for missing genes
  missingGenes <- as.matrix(aucMatrix[,c("missing", "nGenes") , drop=FALSE])
  missingPercent <- as.numeric(missingGenes[,"missing"])/
    as.numeric(missingGenes[,"nGenes"])
  missingPercent <- setNames(missingPercent, rownames(missingGenes))

  if(all(missingPercent>=.80))
    stop("Fewer than 20% of the genes in the gene sets",
         " are included in the rankings.",
         "Check wether the gene IDs in the 'rankings' and 'geneSets' match.")

  if(any(missingPercent>.80))
  {
    warning("The following gene sets will be excluded from the analysis",
            "(less than 20% of their genes are available):\n",
            paste(names(missingPercent)[which(missingPercent >= .80)],
                  collapse=", "),
            immediate.=TRUE)
    aucMatrix <- aucMatrix[which(missingPercent < .80),,drop=FALSE]
  }

  if(sum(missingGenes[,"missing"])>0)
  {
    msg1 <- "Genes in the gene sets NOT available in the dataset: \n"
    msg2 <-  vapply(rownames(missingGenes)[which(missingGenes[,"missing"]>0)],
              function(gSetName)
                paste("\t", gSetName, ": \t", missingGenes[gSetName,"missing"],
                " (",round(missingPercent[gSetName]*100),"% of ",
                missingGenes[gSetName,"nGenes"],")",sep=""),
              FUN.VALUE="")
    if(verbose)
      message(paste(msg1, paste(msg2, collapse="\n"), sep=""))
  }
  # (remove missing genes info from AUC matrix)
  aucMatrix <- aucMatrix[,1:(ncol(aucMatrix)-2), drop=FALSE]


  ######################################################################
  #### End: Return
  names(dimnames(aucMatrix)) <- c("gene-set", "motif")
  new("aucScores",
      SummarizedExperiment::SummarizedExperiment(assays=list(AUC=aucMatrix)),
      org = rankingsInfo["org"],
      genome = rankingsInfo["genome"],
      description = rankingsInfo["description"])
}

.AUC.geneSet <- function(geneSet, rankings, aucMaxRank, gSetName="")
{
  geneSet <- unique(geneSet)
  nGenes <- length(geneSet)
  geneSet <- geneSet[which(geneSet %in% colnames(rankings))]
  missing <- nGenes-length(geneSet)

  # gene names are no longer needed
  gSetRanks <- rankings[,geneSet]
  #rm(rankings)

  aucThreshold <- round(aucMaxRank)
  maxAUC <- aucThreshold * ncol(gSetRanks)  

  auc <- apply(gSetRanks, 1, .auc, aucThreshold, maxAUC)

  c(auc, missing=missing, nGenes=nGenes)
}

# oneRanking <- gSetRanks[,3, with=FALSE]
.auc <- function(oneRanking, aucThreshold, maxAUC)
{
  x <- as.numeric(oneRanking)
  x <- sort(x[x<aucThreshold])

  y <- seq_along(x)
  sum(diff(c(x, aucThreshold)) * y)/maxAUC
}

# Run the enrichment (or load previous results)
load(paste(file.path(system.file('examples', package='RcisTarget')),
           "motifEnrichmentTable_wGenes.RData", sep="/"))

# Add link to logo
newMotifErnTable <- addLogo(motifEnrichmentTable_wGenes)

# Show table
library(DT)
datatable(newMotifErnTable[,-c("enrichedGenes"), with=FALSE],
          escape = FALSE,
          filter="top",
          options=list(pageLength=5))

#' Documentation for the data

#' @rdname dbRegionsLoc
#' @name dbRegionsLoc
#' @aliases dbRegionsLoc_hg19_v9 dbRegionsLoc_mm9_v9
#' @title Genomic location for the database regions
#' @description 
#' \itemize{
#' \item{\bold{dbRegionsLoc_hg19_v9}: }{Contains the location for \bold{HUMAN} regions 
#'   in the database \bold{hg19-regions-9species.all_regions.mc9nr} (hg19,refseq_r45, motif collection v9).
#'   
#'   Source: \emph{hg19__refseq_r45__ClusteredUniformDHS_all_merge_cleaned2_features_rm-insul_rm-exons2_extend.regionid-location.bed}}
#'   
#' \item{\bold{dbRegionsLoc_mm9_v9}: }{Contains the location for \bold{MOUSE} regions 
#'   in the database \bold{mm9-regions-9species.all_regions.mc9nr} (mm9, refseq_r70, motif collection v9).
#' 
#' Source: \emph{mm9__refseq_r70__regulatory_regions.regionid-location.bed}}
#' 
#'\item{For \bold{drosophila}, use the function \code{\link{getDbRegionsLoc}}}
#' }
#' @docType data
#' @seealso https://resources.aertslab.org/cistarget
#' @keywords datasets
NULL

#' @title Import the motif databases for RcisTarget.
#' @param dbFile .feather or .parquet file containing the rankings
#' @param indexCol Column name containing the feature IDs (e.g. motif names or chip-seq tracks). If NULL, it will try to use 'motifs', 'tracks', or 'features'.
#' @param colType Colum type. i.e.:'gene'or 'region'
#' @param columns Columns to load from the .feather or .parquet file
#' (e.g. to read only specific genes or regions)
#' @param warnMissingColumns If 'columns' is provided, warn if any ID is not available in the rankings? 
#' @param dbDescr Description fields (not used in the analysis, just for convenience of the user) 
#' e.g.:
#' \code{dbDescr=list(colType="gene", rowType="motif",
#' org="Human", genome="hg19", maxRank=Inf, description="")}
#' @description
#' The rankings are typically loaded from a .feather or .parquet file
#' with \code{importRankings()}.
#' @return
#' rankingRcisTarget object with the following slots:
#' #' \itemize{
#' \item rankings: data.frame containing the rankings
#' \item colType: 'gene'or 'region'
#' \item nColsInDB: Number of columns (e.g. genes/regions) available
#' in the database (.feather or .parquet file).
#' Note that not all might be loaded in the current object.
#' \item rowType: 'motif' or the type of feature is stored (e.g. ChipSeq)
#' \item org: human/mouse/fly
#' \item genome: hg19, mm9, ...
#' \item description: global description, summary, or any other information
#' \item maxRank: Maximum ranking included in the database,
#' higher values are converted to Inf.
#' }

#' @examples
#' ## Loading from a .feather or .parquet file:
#' # dbFilePath = "hg38_10kbp_up_10kbp_down_full_tx_v10_clust.genes_vs_motifs.rankings.feather"
#' # motifRankings<-importRankings(dbFilePath)
#'
#' ## The annotations for Motif collection 9 (sufix 'mc9nr')
#' # are included in RcisTarget, and can be loaded with:
#' data(motifAnnotations_hgnc)
#'
#' ## For other versions, import the appropiate annotation. e.g.:
#' # annotDb <- importAnnotations("motifs-v10nr_clust-nr.hgnc-m0.001-o0.0.tbl")
#' # optional: motifsInRanking <- getRanking(motifRankings)$motifs

##### Load/import the ranking from a feather file:
#' @rdname importRankings
#' @importFrom arrow read_feather read_parquet FeatherReader ParquetFileReader ReadableFile
#' @import dplyr
#' @importFrom utils read.table
#' @export
importRankings <- function(dbFile, indexCol=NULL, colType="gene", columns=NULL, warnMissingColumns=TRUE, dbDescr=NULL)
{
  dbFile <- path.expand(dbFile)
  if(!file.exists(dbFile)) stop("File does not exist: ", dbFile)
  
  allColumns <- getColumnNames(dbFile)
  indexCol <- .getIndexCol(allColumns, indexCol=indexCol, verbose=warnMissingColumns)
  
  ## If columns are subset: add the index column
  if(!is.null(columns)){
    missingColumns <- columns[which(!columns %in% allColumns)]
    if(length(missingColumns)>0 & warnMissingColumns)
    {
      warning("The following columns are missing from the database: ", paste(missingColumns, collapse=", "))
      columns <- columns[which(columns %in% allColumns)]
    }
    columns <- unique(c(indexCol, columns))
  }
  
  ## Read file (format chosen based on extension)
  extension <- strsplit(dbFile, "\\.") [[1]][length(strsplit(dbFile, "\\.") [[1]])]
  if (extension == 'feather'){
    rnks <- arrow::read_feather(dbFile, col_select=!!columns, mmap = TRUE); dim(rnks)
    nColsInDB <- length(allColumns)-1  #names(arrow::FeatherReader$create(arrow::ReadableFile$create(dbFile)))
  }else if (extension == "parquet"){
    rnks <- arrow::read_parquet(dbFile, columns = !!columns)
    nColsInDB <- length(allColumns)-1 # pq <- arrow::ParquetFileReader(dbFile); pq$GetSchema()$num_fields()-1
  }else{
    stop("Database format must be feather or parquet.")
  }
  
  # The index column should be the first one
  if(!is.null(indexCol)) 
  {
    rnks <- rnks %>% relocate(!!indexCol)
  }
  
  # Add description if available
  if(!is.null(dbDescr))
  {
    dbDescr <- as.matrix(dbDescr)
  } else {
    # If not provided: keep empty
    dbDescr <- as.matrix(list(colType=colType,
                              rowType=indexCol,
                              org="",
                              genome="",
                              nColsAvailable=nColsInDB,
                              maxRank = Inf,
                              description=""))
  }
  
  # Create object
  dbDescr["nColsAvailable",] <- nColsInDB
  dbDescr["description",] <- paste0(dbDescr["description",],
                                    " [Source file: ", basename(dbFile),"]")
  rownames(dbDescr) <- tolower(rownames(dbDescr))
  new("rankingRcisTarget",
      rankings=rnks,
      colType=as.character(dbDescr["coltype",]),
      rowType=as.character(dbDescr["rowtype",]),
      org=as.character(dbDescr["org",]),
      genome=as.character(dbDescr["genome",]),
      nColsInDB=as.numeric(dbDescr["ncolsavailable",]),
      maxRank = as.numeric(dbDescr["maxrank",]),
      description=as.character(dbDescr["description",]))
}

#' @rdname importRankings
#' @export
getRowNames <- function(dbFile, indexCol=NULL)
{
  allColumns <- getColumnNames(path.expand(dbFile))
  indexCol <- .getIndexCol(allColumns, indexCol=indexCol, verbose=FALSE)
  
  dbPath <- dbFile
  extension <- strsplit(dbPath, "\\.") [[1]][length(strsplit(dbPath, "\\.") [[1]])]
  if (extension == 'feather'){
    ret <- unname(unlist(arrow::read_feather(path.expand(dbPath), col_select=indexCol, mmap = TRUE)))
  }
  else if (extension == "parquet"){
    stop("Not implemented") # TODO: add arrow
  }
  return(ret)
}

#' @rdname importRankings
#' @export
getColumnNames <- function(dbFile) # TODO: Check if they are really genes/regions
{
  dbPath <- path.expand(dbFile)
  extension <- strsplit(dbPath, "\\.") [[1]][length(strsplit(dbPath, "\\.") [[1]])]
  if (extension == 'feather'){
    ret <- arrow::ReadableFile$create(dbPath)
    ret <- arrow::FeatherReader$create(ret)
    ret <- names(ret) #[-1]
  }
  else if (extension == "parquet"){
    # ret <- names(arrow::ParquetFileReader$create(arrow::ReadableFile$create(dbPath)))[-1]  #maybe?
    stop("Not implemented") # TODO: add arrow
  }
  return(ret)
}

.getIndexCol <-  function(allColumns, indexCol=NULL, verbose=TRUE)
{
  if(is.null(indexCol)) {
    indexCol <- intersect(allColumns, c('motifs', 'tracks', 'features'))#  [1]
    if(verbose) message("Using the column '", indexCol, "' as feature index for the ranking database.")
  }else{
    if(!indexCol %in% allColumns) stop(paste0("The index column '", indexCol,"' is not available in the file."))
  }
  
  return(indexCol)
}

# Run the enrichment (or load previous results)
load(paste(file.path(system.file('examples', package='RcisTarget')),
           "motifEnrichmentTable_wGenes.RData", sep="/"))

# Show table as HTML
showLogo(motifEnrichmentTable_wGenes)

#' @title Class to store the motif databases for RcisTarget.
#' @aliases rankingRcisTarget-class
#' @param x [several methods] rankingRcisTarget object to apply the method
#' @param object [method: show] rankingRcisTarget object to show
#' 
#' @description
#' This class contains the rankings used by RcisTarget. 
#' 
#' They are typically loaded from a .feather file with \code{importRankings()}.
#' 
#' If the associated .descr file is available, 
#' it will also load the description of the database.
#' 
#' Class slots:
#' 
#' \itemize{
#' \item rankings: data.frame (tbl_df) containing the rankings
#' \item colType: 'gene'or 'region'
#' \item rowType: 'motif' or the type of feature is stored (e.g. ChipSeq)
#' \item org: human/mouse/fly
#' \item genome: hg19, mm9, ...
#' \item nColsInDB: Number of columns (e.g. genes/regions) available 
#' in the database (.feather file). 
#' Note that not all might be loaded in the current object.
#' \item description: global description, summary, or any other information
#' \item maxRank: Maximum ranking included in the database, 
#' higher values are converted to Inf.
#' }
#' 
#' Note that the main slot is \code{@rankings}, 
#' which is the one used by RcisTarget 
#' (it can accessed with \code{getRanking()}).
#' The 'description' slots are mostly for user convenience. 
#' 
## @example inst/examples/example_class_rcos.R
#' @return
#' \itemize{
#' \item show: Prints a summary of the object
#' \item getRanking: Returns the rankings
#' \item ncol, nrow: Returns the number of columns or rows of the ranking
#' }

#' @examples
#' ## Loading from a .feather file:
#' # dbFile <- "hg19-500bp-upstream-7species.mc9nr.feather"
#' # motifRankings <- importRankings(dbFile)
#' # motifRankings
#' 
#' ## Loading a built object:
#' library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
#' data("hg19_500bpUpstream_motifRanking_cispbOnly")
#' hg19_500bpUpstream_motifRanking_cispbOnly
#' class(hg19_500bpUpstream_motifRanking_cispbOnly)
#' @importFrom methods slotNames
#' @importClassesFrom tibble tbl_df
#' @rdname rankingRcisTarget-class
#' @export rankingRcisTarget
#' @exportClass rankingRcisTarget
rankingRcisTarget <- setClass(
  # Set the name for the class
  Class="rankingRcisTarget",
  
  slots = c(
    rankings = "tbl_df", # "data.frame",
    colType = "character", # gene/region
    rowType = "character", # motif or whatever feature is stored (e.g. ChipSeq)
    org = "character", # human/mouse
    genome = "character", # hg19, mm9 ...
    nColsInDB="numeric", # Number of columns (e.g. genes) available in DB
    maxRank = "numeric", # Higher ranks are converted to Inf
    description = "character", # Other info, shown with "show"
    rcistarget_version = "character" # Class/RcisTarget version
  )
)

#' @rdname rankingRcisTarget-class
#' @aliases show,rankingRcisTarget-method
#' @export
setMethod("show",
  signature="rankingRcisTarget",
  definition = function(object) {
    message <- paste("Rankings for RcisTarget.\n")
    
    if((object@org != "") || (object@genome != ""))
    {
      genome <- ""
      if((object@genome != ""))
        genome <- paste0(" (", object@genome,")")
      message <- paste0(message,
      "  Organism: ", object@org, genome,"\n")
    }
    
    nGenes <- ncol(getRanking(object))-1
    if(("nColsInDB" %in% slotNames(object)) && !is.na(object@nColsInDB)) nGenes <- paste0(nGenes," (",object@nColsInDB," available in the full DB)")
    message <- paste0(message,
     "  Number of ",object@colType, "s: ", nGenes, "\n",
     "  Number of ",toupper(object@rowType),": ",nrow(getRanking(object)),"\n"
     )
    
    if(getMaxRank(object) < Inf)
    {
      message <- paste(message,
        "** This database includes rankings up to ", 
        getMaxRank(object), "\n", sep="")
    }
    
    if(length(object@description)>0)
    {
      message <- paste(message, "\n",
                       object@description,
                       "\n", sep="")
    }
    
    
    cat(message)
  }
)

##### Access the rankings:
#' @importFrom AUCell getRanking
#' @name getRanking
#' @rdname rankingRcisTarget-class
#' @aliases getRanking,rankingRcisTarget-method
#' @exportMethod getRanking
setMethod("getRanking",
          signature="rankingRcisTarget",
          definition = function(object) {
            object@rankings
          }
)

#' @importFrom BiocGenerics nrow
#' @rdname rankingRcisTarget-class
#' @aliases nrow,rankingRcisTarget-method
#' @export
setMethod("nrow",
          signature="rankingRcisTarget",
          definition = function(x) {
            nrow(getRanking(x))
          }
)

#' @importFrom BiocGenerics ncol
#' @rdname rankingRcisTarget-class
#' @aliases ncol,rankingRcisTarget-method
#' @export
setMethod("ncol",
          signature="rankingRcisTarget",
          definition = function(x) {
            ncol(getRanking(x))
          }
)


#' @importFrom BiocGenerics colnames
#' @rdname rankingRcisTarget-class
#' @aliases colnames,rankingRcisTarget-method
#' @export
setMethod("colnames",
          signature="rankingRcisTarget",
          definition = function(x) {
            colnames(getRanking(x)[-1])
          }
)

#' @importFrom BiocGenerics rownames
#' @rdname rankingRcisTarget-class
#' @aliases rownames,rankingRcisTarget-method
#' @export
setMethod("rownames",
          signature="rankingRcisTarget",
          definition = function(x) {
            rownames(getRanking(x))
          }
)

##### Access the maxRank:
setGeneric(name="getMaxRank",
           def=function(x) standardGeneric("getMaxRank"))
#' @name getMaxRank
#' @rdname rankingRcisTarget-class
#' @aliases getMaxRank,rankingRcisTarget-method
#' @export
setMethod("getMaxRank",
          signature="rankingRcisTarget",
          definition = function(x) {
            # Previous versions didn't have @maxRank -> Contain all ranks
            ret <- tryCatch(
              x@maxRank,
              error=function(e) {Inf}
            )
            
            if(length(ret)==0)
              ret <- Inf
            
            return(ret)
          }
)

##### Access the nColsAvailable:
setGeneric(name="getNumColsInDB",
           def=function(x) standardGeneric("getNumColsInDB"))
#' @name getNumColsInDB
#' @rdname rankingRcisTarget-class
#' @aliases getNumColsInDB,rankingRcisTarget-method
#' @export
setMethod("getNumColsInDB",
          signature="rankingRcisTarget",
          definition = function(x) {
            ret <- tryCatch(
              x@nColsInDB,
              error=function(e) {NA}
            )
            
            if(length(ret)==0)
              ret <- NA
            
            return(ret)
          }
)

---
title: "Motif enrichment with background"
abstract: >
  This tutorial shows how to use **RcisTarget** with background.
vignette: >
  %\VignetteIndexEntry{RcisTarget - with background}
  %\VignetteEngine{knitr::rmarkdown}
output: 
  html_document:
    toc: yes
    toc_float: yes
    number_sections: false
  pdf_document:
    toc: yes
  html_notebook:
    toc: yes
---

```{r libraries, echo=FALSE, message=FALSE, warning=FALSE}
suppressPackageStartupMessages({
library(RcisTarget)
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp) 
library(DT)
library(data.table)
#require(visNetwork)
})
```

This tutorial requires RcisTarget \>= 1.7.1.

```{r}
packageVersion("RcisTarget")
```

### 1. Select the gene/region set to analyze & the "background"

```{r}
# Genes to analyze:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),"hypoxiaGeneSet.txt", sep="/")
geneSets <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

# Background: 
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),"randomGeneSet.txt", sep="/") # for the toy example we will use a few random genes
background <- read.table(txtFile, stringsAsFactors=FALSE)[,1]
```

The background should contain the target genes/regions.

If for any reason that is not the case, you can **add** the target genes to the background, or **remove** the target genes missing from the background (depending on what makes more sense in your specific analysis).

```{r}
# A: Add
background <- unique(c(geneSets$hypoxia, background))
# B: Intersect
# geneSets$hypoxia <- intersect(geneSets$hypoxia, background)
```

```{r fig.height=3, fig.width=3}
gplots::venn(list(background=background, geneLists=unlist(geneSets)))
```

### 2. Create the background-ranking

Select the appropriate ranking-database:

```{r eval=FALSE}
dbPath <- "~/databases/hg19-500bp-upstream-10species.mc9nr.feather"
```

Load the database and re-rank the genes/motifs (e.g. only within the "background+foreground")

```{r eval=FALSE}
library(RcisTarget)
rankingsDb <- importRankings(dbPath, columns=background)
bgRanking <- reRank(rankingsDb) 
```

### 3. Run RcisTarget with this new ranking

Once the "background-ranking" is ready, just use it to run RcisTarget as usual:

> Note: Since the 'background database' is typically much smaller than the full database (it has fewer genes or regions), we recommend to use `geneErnMethod = "icistarget"` instead of 'aprox'.

```{r eval=FALSE}
motifEnrichmentTable <- cisTarget(geneSets, bgRanking, 
                                  aucMaxRank=0.03*getNumColsInDB(bgRanking),
                                  geneErnMaxRank=getNumColsInDB(bgRanking),
                                  geneErnMethod = "icistarget")
```

```{r eval=FALSE}
showLogo(motifEnrichmentTable)
```

---
title: "Motif enrichment in genomic regions"
abstract: >
  Example using **RcisTarget** to analyze genomic regions (instead of genes).
vignette: >
  %\VignetteIndexEntry{RcisTarget - on regions}
  %\VignetteEngine{knitr::rmarkdown}
output: 
  html_document:
    toc: yes
    toc_float: yes
    number_sections: false
  pdf_document:
    toc: yes
  html_notebook:
    toc: yes
---
```{r libraries, echo=FALSE, message=FALSE, warning=FALSE}
suppressPackageStartupMessages({
library(RcisTarget)
})
```

This tutorial requires RcisTarget >= 1.11
```{r}
packageVersion("RcisTarget")
```

### 1. Prepare/download the input regions

```{r}
download.file("https://gbiomed.kuleuven.be/apps/lcb/i-cisTarget/examples/input_files/human/peaks/Encode_GATA1_peaks.bed", "Encode_GATA1_peaks.bed")
regionsList <- rtracklayer::import.bed("Encode_GATA1_peaks.bed")
regionSets <- list(GATA1_peaks=regionsList)
```

### 2. Load the RcisTarget databases

This analysis requires the region-based databases (for the appropriate organism):
- Region-based motif rankings
- Motif-TF annotations (same for region- & gene-based analysis)
- Region location (i.e. conversion from region ID to genomic location)

The databases can be downloaded from: https://resources.aertslab.org/cistarget/ 

Note: This example uses an old version of the database (mc9nr), 
we recommend to use the latest version (v10_clus).

```{r eval=FALSE}
library(RcisTarget)
# Motif rankings
featherFilePath <- "~/databases/hg19-regions-9species.all_regions.mc9nr.feather"

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9

# Regions location *
data(dbRegionsLoc_hg19)
dbRegionsLoc <- dbRegionsLoc_hg19
```

* Note: The region location is only needed for human and mouse databases.
For **drosophila**, the region ID contains the location, and can be obtained with:
```{r eval=FALSE}
dbRegionsLoc <- getDbRegionsLoc(featherFilePath)
``` 

### 3. Run the analysis

The main difference with a gene-based analysis is that the regions need to be converted to the database IDs first, and the parameter `aucMaxRank` should be adjusted:

* For Human: `aucMaxRank= 0.005`
* For Mouse: `aucMaxRank= 0.005` 
* For Fly: `aucMaxRank= 0.01`

```{r eval=FALSE}
# Convert regions
regionSets_db <- lapply(regionSets, function(x) convertToTargetRegions(queryRegions=x, targetRegions=dbRegionsLoc))

# Import rankings
allRegionsToImport <- unique(unlist(regionSets_db)); length(allRegionsToImport)
motifRankings <- importRankings(featherFilePath, columns=allRegionsToImport)

# Run RcisTarget
motifEnrichmentTable <- cisTarget(regionSets_db, motifRankings, aucMaxRank=0.005*getNumColsInDB(motifRankings))

# Show output:
showLogo(motifEnrichmentTable)
```

---
title: "RcisTarget: Transcription factor binding motif enrichment"
abstract: >
  This tutorial shows how to use **RcisTarget** to obtain  
  transcription factor binding motifs enriched on a gene list. 
vignette: >
  %\VignetteIndexEntry{RcisTarget: Transcription factor binding motif enrichment}
  %\VignetteEngine{knitr::rmarkdown}
output: 
  html_document:
    toc: yes
    toc_float: yes
    number_sections: false
  pdf_document:
    toc: yes
  html_notebook:
    toc: yes
editor_options: 
  markdown: 
    wrap: sentence
---

```{r libraries, echo=FALSE, message=FALSE, warning=FALSE}
suppressPackageStartupMessages({
library(RcisTarget)
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp) 
library(DT)
library(data.table)
#require(visNetwork)
})
```

*Vignette built on `r format(Sys.time(), "%b %d, %Y")` with RcisTarget **version `r packageVersion("RcisTarget")`***.

# What is RcisTarget?

RcisTarget is an R-package to identify transcription factor (TF) binding motifs over-represented on a gene list.

RcisTarget is based on the methods previously implemented in [i-cisTarget](http://gbiomed.kuleuven.be/apps/lcb/i-cisTarget) (web interface, region-based) and [iRegulon](http://iregulon.aertslab.org) (Cytoscape plug-in, gene-based).

If you use RcisTarget in your research, please cite:

```{r citation, echo=FALSE}
print(citation("RcisTarget")[1], style="textVersion")
```

# Overview of the workflow

The function `cisTarget()` allows to perform the motif-enrichment analysis on a gene list.
The main input parameters are the gene list and the motif databases, which should be chosen depending on the organism and the search space around the TSS of the genes.
This is a sample on how to run the analysis (see the following sections for details):

```{r overview, eval=FALSE}
library(RcisTarget)

# Load gene sets to analyze. e.g.:
geneList1 <- read.table(file.path(system.file('examples', package='RcisTarget'), "hypoxiaGeneSet.txt"), stringsAsFactors=FALSE)[,1]
geneLists <- list(geneListName=geneList1)
# geneLists <- GSEABase::GeneSet(genes, setName="geneListName") # alternative

# Select motif database to use (i.e. organism and distance around TSS)
data(motifAnnotations_hgnc)
motifRankings <- importRankings("~/databases/hg38_10kbp_up_10kbp_down_full_tx_v10_clust.genes_vs_motifs.rankings.feather")

# Motif enrichment analysis:
motifEnrichmentTable_wGenes <- cisTarget(geneLists, motifRankings,
                               motifAnnot=motifAnnotations)
```

**Advanced use**: The `cisTarget()` function is enough for most simple analyses.
However, for further flexibility (e.g. removing unnecessary steps on bigger analyses), RcisTarget also provides the possibility to run the inner functions individually.
Running `cisTarget()` is equivalent to running this code:

```{r overviewAdvanced, eval=FALSE}
# 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)

# 2. Select significant motifs, add TF annotation & format as table
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC, 
                          motifAnnot=motifAnnotations)

# 3. Identify significant genes for each motif
# (i.e. genes from the gene set in the top of the ranking)
# Note: Method 'iCisTarget' instead of 'aprox' is more accurate, but slower
motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable, 
                                                   geneSets=geneLists,
                                                   rankings=motifRankings, 
                                                   nCores=1,
                                                   method="aprox")
```

# Before starting

## Setup

RcisTarget uses species-specific databases which are provided as independent R-packages.
Prior to running RcisTarget, you will need to download and install the databases for the relevant organism (more details in the "Motif databases" section).

In addition, some extra packages can be installed to run RcisTarget in parallel or run the interactive examples in this tutorial:

```{r installDep, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
# To support paralell execution:
BiocManager::install(c("doMC", "doRNG"))
# For the examples in the follow-up section of the tutorial:
BiocManager::install(c("DT", "visNetwork"))
```

## Some tips...

### Help

At any time, remember you an access the help files for any function (i.e. `?cisTarget`), and the other tutorials in the package with the following commands:

```{r vignette, eval=FALSE}
# Explore tutorials in the web browser:
browseVignettes(package="RcisTarget") 

# Commnad line-based:
vignette(package="RcisTarget") # list
vignette("RcisTarget") # open
```

### Reports

To generate an HTML report with your own data and comments, you can use the `.Rmd file` of this tutorial as template (i.e. copy the .Rmd file, and edit it as [R notebook](http://rmarkdown.rstudio.com/r_notebooks.html) in RStudio).

```{r editRmd, eval=FALSE}
vignetteFile <- paste(file.path(system.file('doc', package='RcisTarget')), 
                      "RcisTarget.Rmd", sep="/")
# Copy to edit as markdown
file.copy(vignetteFile, ".")
# Alternative: extract R code
Stangle(vignetteFile)
```

# Running RcisTarget

## Input: Gene sets

The main input to RcisTarget is the gene set(s) to analyze.
The gene sets can be provided as a 'named list' in which each element is a gene-set (character vector containing gene names) or as a `GSEABase::GeneSet`.
The gene-set name will be used as ID in the following steps.

```{r geneSets}
library(RcisTarget)
geneSet1 <- c("gene1", "gene2", "gene3")
geneLists <- list(geneSetName=geneSet1)
# or: 
# geneLists <- GSEABase::GeneSet(geneSet1, setName="geneSetName") 
```

Some extra help:

```{r geneSetsFormat, eval=FALSE}
class(geneSet1)
class(geneLists)
geneSet2 <- c("gene2", "gene4", "gene5", "gene6")
geneLists[["anotherGeneSet"]] <- geneSet2
names(geneLists)
geneLists$anotherGeneSet
lengths(geneLists)
```

In this example we will be using a list of genes up-regulated in MCF7 cells under hypoxia conditions ([PMID:16565084](https://www.ncbi.nlm.nih.gov/pubmed/?term=16565084)).

The original work highlighted the role of hypoxia-inducible factor (HIF1-alpha or HIF1A) pathways under hypoxia.
This gene list is also used for the turorials in iRegulon (<http://iregulon.aertslab.org/tutorial.html>).

```{r sampleGeneSet}
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])
head(geneLists$hypoxia)
```

## Required databases

To analyze the gene list, RcisTarget needs two types of databases: 

- 1. Gene-motif rankings: which provides the rankings (based on the motif score) of all the genes for each motif.

- 2. The annotation of motifs to transcription factors.

### Gene-motif rankings

The score of each pair of gene-motif can be performed using different parameters.
Therefore, we provide multiple databases ([motif-rankings](https://resources.aertslab.org/cistarget/), or alternative: [mirror](https://resources-mirror.aertslab.org/cistarget/)), according to several possibilities:

-   Species: Species of the input gene set. *Available values: Human (Homo sapiens), mouse (Mus musculus) or fly (Drosophila melanogaster)*
-   Scoring/search space: determine the search space around the transcription start site (TSS). *Available values: 500 bp uptream the TSS, 5kbp or 10kbp around the TSS (e.g. 10kbp upstream and 10kbp downstream of the TSS).*
- Motif collection: We recommend to use the latest one (mc10_clust).

If you don't know which database to choose, for an analisis of a gene list we would suggest using the *500bp upstream TSS*, and a larger search space (e.g. *TSS+/-5kbp* or *TSS+/-10kbp*).
Of course, selecting Human, Mouse or fly depending on your input gene list.

For other settings (e.g. **new species**), you can check the tutorial on how to [create databases](https://github.com/aertslab/create_cisTarget_databases).

Each database is stored in a `.feather` file.
Note that the download size is typically over 1GB (100GB for human region databases), we recommend downloading the files with `zsync_curl`\` (see the [Help with downloads](https://resources.aertslab.org/cistarget/help.html)).

Once you have the .feather files, they can be loaded with `importRankings()`:

```{r loadDatabases, eval=FALSE}
# Search space: 10k bp around TSS - HUMAN
motifRankings <- importRankings("hg38_10kbp_up_10kbp_down_full_tx_v10_clust.genes_vs_motifs.rankings.feather")
# Load the annotation to human transcription factors
data(motifAnnotations_hgnc)
```

### Motif annotations

All the calculations performed by RcisTarget are motif-based.
However, most users will be interested on TFs potentially regulating the gene-set.
The association of motif to transcription factors are provided in an independent file.
In addition to the motifs annotated by the source datatabse (i.e. **direct** annotation), we have also **inferred** some further annotations based on motif similarity and gene ortology (e.g. similarity to other genes annotated to the motif).
These annotations are typically used with the functions `cisTarget()` or `addMotifAnnotation()`.

For the motifs in version 'mc10nr' of the rankings, these annotations are already included in RcisTarget package and can be loaded with the command:

```{r loadAnnot, eval=TRUE}
# mouse:
# data(motifAnnotations_mgi)

# human:
data(motifAnnotations_hgnc)
motifAnnotations[199:202,]
```

For other versions of the rankings, the function `importAnnotations` allows to import the annotations from the source file.

These annotations can be easily queried to obtain further information about specific motifs or TFs:

```{r motifAnnotQuery}
showLogo(motifAnnotations[(directAnnotation==TRUE) & keptInRanking 
                               & (TF %in% c("HIF1A", "HIF2A", "EPAS1")), ])
```

#### Database example (subset)

In addition to the full versions of the databases (~20k motifs), we also provide a subset containing only the 4.6k motifs from cisbp (human only: *RcisTarget.hg19.motifDBs.cisbpOnly.500bp*).
These subsets are available in Bioconductor for demonstration purposes.
They will provide the same AUC score for the existing motifs.
However, we highly recommend to use the full version (\~20k motifs) for more accurate results, since the normalized enrichment score (NES) of the motif depends on the total number of motifs in the database.

To install this package:

```{r installDatabases, eval=FALSE}
# From Bioconductor
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("RcisTarget.hg19.motifDBs.cisbpOnly.500bp")
```

For this vignette (demonstration purposes), we will use this database:

```{r loadDatabasesCisbpOnly}
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
# Rankings
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly
motifRankings

# Annotations
data(hg19_motifAnnotation_cisbpOnly) 
motifAnnotations <- hg19_motifAnnotation_cisbpOnly
```

## Running the analysis

Once the gene lists and databases are loaded, they can be used by `cisTarget()`.
`cisTarget()` runs sequentially the steps to perform the (**1**) motif enrichment analysis, (**2**) motif-TF annotation, and (**3**) selection of significant genes.

It is also possible to run these steps as individual commands.
For example, to skip steps, for analyses in which the user is interested in one of the outputs, or to optimize the workflow to run it on multiple gene lists (see *Advanced* section for details).

```{r eval=FALSE}
motifEnrichmentTable_wGenes <- cisTarget(geneLists, 
         motifRankings,
         motifAnnot=motifAnnotations)
```

## Advanced: Execute step by step

### 1. Calculate enrichment

The first step to estimate the over-representation of each motif on the gene-set is to calculate the Area Under the Curve (AUC) for each pair of motif-geneSet.
This is calculated based on the recovery curve of the gene-set on the motif ranking (genes ranked decreasingly by the score of motif in its proximity, as provided in the motifRanking database).

```{r calcAUC, cache=TRUE}
motifs_AUC <- calcAUC(geneLists, motifRankings, nCores=1)
```

The AUC is provided as a matrix of Motifs by GeneSets.
In principle, the AUC is mostly meant as input for the next step.
However, it is also possible to explore the distribution of the scores, for example in a gene-set of interest:

```{r AUChistogram, cache=TRUE, fig.height=5, fig.width=5}
auc <- getAUC(motifs_AUC)["hypoxia",]
hist(auc, main="hypoxia", xlab="AUC histogram",
     breaks=100, col="#ff000050", border="darkred")
nes3 <- (3*sd(auc)) + mean(auc)
abline(v=nes3, col="red")
```

### 2. Select significant motifs and/or annotate to TFs

The selection of significant motifs is done based on the Normalized Enrichment Score (NES).
The NES is calculated -for each motif- based on the AUC distribution of all the motifs for the gene-set [(x-mean)/sd].
Those motifs that pass the given threshold (3.0 by default) are considered significant.

Furthermore, this step also allows to add the TFs annotated to the motif.

```{r addMotifAnnotation, cache=TRUE}
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC, nesThreshold=3,
     motifAnnot=motifAnnotations,
     highlightTFs=list(hypoxia=c("HIF1A", "EPAS1")))
```

```{r}
class(motifEnrichmentTable)
dim(motifEnrichmentTable)
head(motifEnrichmentTable[,-"TF_lowConf", with=FALSE])
```

The cathegories considered high/low confidence can me modified with the arguments `motifAnnot_highConfCat` and `motifAnnot_lowConfCat`.

### 3. Identify the genes with the best enrichment for each Motif

Since RcisTarget searches for enrichment of a motif within a gene list, finding a motif 'enriched' does not imply that *all* the genes in the gene-list have a high score for the motif.
In this way, the third step of the workflow is to identify which genes (of the gene-set) are highly ranked for each of the significant motifs.

There are two methods to identify these genes: (1) equivalent to the ones used in iRegulon and i-cisTarget (`method="iCisTarget"`, recommended if running time is not an issue), and (2) a faster implementation based on an approximate distribution using the average at each rank (`method="aprox"`, useful to scan multiple gene sets).

IMPORTANT: Make sure that the **motifRankings** are the **same as in Step 1**.

```{r addSignificantGenes, cache=TRUE}
motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable,
                      rankings=motifRankings, 
                      geneSets=geneLists)
dim(motifEnrichmentTable_wGenes)
```

Plot for a few motifs:

```{r getSignificantGenes, fig.height=7, fig.width=7}
geneSetName <- "hypoxia"
selectedMotifs <- c(sample(motifEnrichmentTable$motif, 2))
par(mfrow=c(2,2))
getSignificantGenes(geneLists[[geneSetName]], 
                    rankings=motifRankings,
                    signifRankingNames=selectedMotifs,
                    plotCurve=TRUE, maxRank=5000, genesFormat="none",
                    method="aprox")
```

## Output

The final output of RcisTarget is a `data.table` containing the information about the motif enrichment and its annotation organized in the following fields:

-   geneSet: Name of the gene set
-   motif: ID of the motif
-   NES: Normalized enrichment score of the motif in the gene-set
-   AUC: Area Under the Curve (used to calculate the NES)
-   TFinDB: Indicates whether the *highlightedTFs* are included within the high confidence annotation (two asterisks) or low confidence annotation (one asterisk).
-   TF_highConf: Transcription factors annotated to the motif according to 'motifAnnot_highConfCat'.
-   TF_lowConf: Transcription factors annotated to the motif according to 'motifAnnot_lowConfCat'.
-   enrichedGenes: Genes that are highly ranked for the given motif.
-   nErnGenes: Number of genes highly ranked
-   rankAtMax: Ranking at the maximum enrichment, used to determine the number of enriched genes.

```{r output}
resultsSubset <- motifEnrichmentTable_wGenes[1:10,]
showLogo(resultsSubset)
```

# Follow up examples

## TFs annotated to the enriched motifs

Note that the TFs are provided based on the motif annotation.
They can be used as a guide to select relevant motifs or to prioritize some TFs, but the motif annotation does not imply that all the TFs appearing in the table regulate the gene list.

```{r anotatedTfs, cache=TRUE}
anotatedTfs <- lapply(split(motifEnrichmentTable_wGenes$TF_highConf,
                            motifEnrichmentTable$geneSet),
                      function(x) {
                        genes <- gsub(" \\(.*\\). ", "; ", x, fixed=FALSE)
                        genesSplit <- unique(unlist(strsplit(genes, "; ")))
                        return(genesSplit)
                        })
                      
anotatedTfs$hypoxia
```

## Building a network

```{r network, cache=FALSE, eval=FALSE}
signifMotifNames <- motifEnrichmentTable$motif[1:3]

incidenceMatrix <- getSignificantGenes(geneLists$hypoxia, 
                                       motifRankings,
                                       signifRankingNames=signifMotifNames,
                                       plotCurve=TRUE, maxRank=5000, 
                                       genesFormat="incidMatrix",
                                       method="aprox")$incidMatrix

library(reshape2)
edges <- melt(incidenceMatrix)
edges <- edges[which(edges[,3]==1),1:2]
colnames(edges) <- c("from","to")
```

*Output not shown:*

```{r visNetwork, eval=FALSE}
library(visNetwork)
motifs <- unique(as.character(edges[,1]))
genes <- unique(as.character(edges[,2]))
nodes <- data.frame(id=c(motifs, genes),   
      label=c(motifs, genes),    
      title=c(motifs, genes), # tooltip 
      shape=c(rep("diamond", length(motifs)), rep("elypse", length(genes))),
      color=c(rep("purple", length(motifs)), rep("skyblue", length(genes))))
visNetwork(nodes, edges) %>% visOptions(highlightNearest = TRUE, 
                                        nodesIdSelection = TRUE)
```

# sessionInfo()

This is the output of `sessionInfo()` on the system on which this document was compiled:

```{r}
date()
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_dbRegionsLoc.R
\docType{data}
\name{dbRegionsLoc}
\alias{dbRegionsLoc}
\alias{dbRegionsLoc_hg19_v9}
\alias{dbRegionsLoc_mm9_v9}
\title{Genomic location for the database regions}
\description{
\itemize{
\item{\bold{dbRegionsLoc_hg19_v9}: }{Contains the location for \bold{HUMAN} regions 
  in the database \bold{hg19-regions-9species.all_regions.mc9nr} (hg19,refseq_r45, motif collection v9).
  
  Source: \emph{hg19__refseq_r45__ClusteredUniformDHS_all_merge_cleaned2_features_rm-insul_rm-exons2_extend.regionid-location.bed}}
  
\item{\bold{dbRegionsLoc_mm9_v9}: }{Contains the location for \bold{MOUSE} regions 
  in the database \bold{mm9-regions-9species.all_regions.mc9nr} (mm9, refseq_r70, motif collection v9).

Source: \emph{mm9__refseq_r70__regulatory_regions.regionid-location.bed}}

\item{For \bold{drosophila}, use the function \code{\link{getDbRegionsLoc}}}
}
}
\details{
Documentation for the data
}
\seealso{
https://resources.aertslab.org/cistarget
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/01_calcAUC.R
\name{calcAUC}
\alias{calcAUC}
\alias{calcAUC,list-method}
\alias{calcAUC,character-method}
\alias{calcAUC,GeneSet-method}
\alias{calcAUC,GeneSetCollection-method}
\title{Calculate AUC}
\usage{
calcAUC(
  geneSets,
  rankings,
  nCores = 1,
  aucMaxRank = 0.03 * getNumColsInDB(rankings),
  verbose = TRUE
)

\S4method{calcAUC}{list}(
  geneSets,
  rankings,
  nCores = 1,
  aucMaxRank = 0.03 * getNumColsInDB(rankings),
  verbose = TRUE
)

\S4method{calcAUC}{character}(
  geneSets,
  rankings,
  nCores = 1,
  aucMaxRank = 0.03 * getNumColsInDB(rankings),
  verbose = TRUE
)

\S4method{calcAUC}{GeneSet}(
  geneSets,
  rankings,
  nCores = 1,
  aucMaxRank = 0.03 * getNumColsInDB(rankings),
  verbose = TRUE
)

\S4method{calcAUC}{GeneSetCollection}(
  geneSets,
  rankings,
  nCores = 1,
  aucMaxRank = 0.03 * getNumColsInDB(rankings),
  verbose = TRUE
)
}
\arguments{
\item{geneSets}{List of gene-sets to analyze.
The gene-sets should be provided as \code{\link{GeneSet}},
\code{\link{GeneSetCollection}} or character list (see examples).}

\item{rankings}{'Motif rankings' database for the required organism and
search-space (i.e. 10kbp around- or 500bp upstream the TSS).
These objects are provided in separate files, 
which can be imported with \code{importRankings()}:
\itemize{
\item \url{http://pyscenic.aertslab.org/databases/mm9-500bp-upstream-7species.mc9nr.feather}[mm9-500bp-upstream-7species.mc9nr] (Mouse, 500bp)
\item \url{http://pyscenic.aertslab.org/databases/mm9-tss-centered-10kb-7species.mc9nr.feather}[mm9-tss-centered-10kb-7species.mc9nr] (Mouse, 10kbp)
\item \url{http://pyscenic.aertslab.org/databases/hg19-500bp-upstream-7species.mc9nr.feather}[hg19-500bp-upstream-7species.mc9nr] (Human, 500bp)
\item \url{http://pyscenic.aertslab.org/databases/hg19-tss-centered-10kb-7species.mc9nr.feather}[hg19-tss-centered-10kb-7species.mc9nr] (Human, 10kbp)
\item -Coming soon- (Fly)
}
See \code{vignette("RcisTarget")} for an exhaustive list of databases.

Since the normalized enrichment score (NES) of the motif
depends on the total number of motifs in the database,
we highly recommend to use the full version of the databases (20k motifs).
A smaller version of the human databases,
containing only the 4.6k motifs from cisbp,
are available in Bioconductor:
\itemize{
\item RcisTarget.hg19.motifDBs.cisbpOnly.500bp (Human)
}}

\item{nCores}{Number of cores to use for computation.
Note: In general, using a higher number of cores (e.g. processes)
decreases overall running time.
However, it also deppends on the available memory and overall system load.
Setting nCores too high might also decrease performance.}

\item{aucMaxRank}{Threshold to calculate the AUC.
In a simplified way, the AUC value represents the fraction of genes,
within the top X genes in the ranking, that are included in the signature.
The parameter 'aucMaxRank' allows to modify the number of genes
(maximum ranking) that is used to perform this computation.
By default it is set to 5\% of the total number of genes in the rankings.
Common values range from 1 to 10\%.
See \code{vignette("RcisTarget")} for examples and more details.}

\item{verbose}{Should the function show progress messages? (TRUE / FALSE)}
}
\value{
\code{\link{aucScores}} of gene-sets (columns) by motifs (rows)
with the value of AUC for each pair as content.
}
\description{
Calculates the Area Under the Curve (AUC) of each gene-set
for each motif ranking.
This measure is used in the following steps to identify the DNA motifs
that are significantly over-represented in the gene-set.
}
\examples{
# RcisTarget workflow for advanced users:
# Running the workflow steps individually

\dontrun{
  
##################################################
#### Load your gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
               "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])
  
#### Load databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
motifRankings <- importRankings("hg19-500bp-upstream-7species.mc9nr.feather")

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9
##################################################

#### Run RcisTarget

# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)

# Step 2. Select significant motifs, add TF annotation & format as table
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                         motifAnnot=motifAnnotation)

# Step 3 (optional). Identify genes that have the motif significantly enriched
# (i.e. genes from the gene set in the top of the ranking)
motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable,
                                                   geneSets=geneLists,
                                                   rankings=motifRankings,
                                                   method="aprox")

}
}
\seealso{
Next step in the workflow: \code{\link{addMotifAnnotation}}.

See the package vignette for examples and more details:
\code{vignette("RcisTarget")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_convertToTargetRegions.R
\name{convertToTargetRegions}
\alias{convertToTargetRegions}
\title{convertToTargetRegions}
\usage{
convertToTargetRegions(
  queryRegions,
  targetRegions,
  minOverlap = 0.4,
  overlapType = "any",
  returnCorrespondence = FALSE,
  verbose = TRUE
)
}
\arguments{
\item{queryRegions}{List of regions to convert (normally the query region set).}

\item{targetRegions}{List of regions in the target set (normally the database).}

\item{minOverlap}{Minimum overlap to consider (in either direction, default: 0.40).}

\item{overlapType}{Parameter for \code{findOverlaps} (default: "any")}

\item{returnCorrespondence}{Returns a table containing the matches, 
or only a list of overlapping regions (default: FALSE).}

\item{verbose}{Print the number of regions selected?}
}
\value{
IDs of the regions in the "target regions" overlapping with the query regions.
}
\description{
Convert a set of input regions to the overlapping regions in the target set.
}
\examples{
\dontrun{
 ## To apply on a list of regionSets:
 regionSets_db <- lapply(regionSets, function(x) 
    convertToTargetRegions(queryRegions=x, targetRegions=dbRegionsLoc))
 }
}
\seealso{
\code{\link{getDbRegionsLoc}}.

See the package vignette for examples and more details:
\code{vignette("RcisTarget")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/03_addSignificantGenes.R
\name{addSignificantGenes}
\alias{addSignificantGenes}
\alias{addSignificantGenes,list-method}
\alias{addSignificantGenes,character-method}
\alias{addSignificantGenes,GeneSet-method}
\alias{addSignificantGenes,GeneSetCollection-method}
\alias{getSignificantGenes}
\alias{getSignificantGenes,list-method}
\alias{getSignificantGenes,character-method}
\alias{getSignificantGenes,factor-method}
\alias{getSignificantGenes,GeneSet-method}
\alias{getSignificantGenes,GeneSetCollection-method}
\title{Add significant genes}
\usage{
addSignificantGenes(
  resultsTable,
  geneSets,
  rankings,
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = "geneList",
  method = "aprox",
  nMean = 50,
  nCores = 1
)

\S4method{addSignificantGenes}{list}(
  resultsTable,
  geneSets,
  rankings,
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = "geneList",
  method = "aprox",
  nMean = 50,
  nCores = 1
)

\S4method{addSignificantGenes}{character}(
  resultsTable,
  geneSets,
  rankings,
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = "geneList",
  method = "aprox",
  nMean = 50,
  nCores = 1
)

\S4method{addSignificantGenes}{GeneSet}(
  resultsTable,
  geneSets,
  rankings,
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = "geneList",
  method = "aprox",
  nMean = 50,
  nCores = 1
)

\S4method{addSignificantGenes}{GeneSetCollection}(
  resultsTable,
  geneSets,
  rankings,
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = "geneList",
  method = "aprox",
  nMean = 50,
  nCores = 1
)

getSignificantGenes(
  geneSet,
  rankings,
  signifRankingNames = NULL,
  method = "iCisTarget",
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = c("geneList", "incidMatrix"),
  nCores = 1,
  digits = 3,
  nMean = 50
)

\S4method{getSignificantGenes}{list}(
  geneSet,
  rankings,
  signifRankingNames = NULL,
  method = "iCisTarget",
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = c("geneList", "incidMatrix"),
  nCores = 1,
  digits = 3,
  nMean = 50
)

\S4method{getSignificantGenes}{character}(
  geneSet,
  rankings,
  signifRankingNames = NULL,
  method = "iCisTarget",
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = c("geneList", "incidMatrix"),
  nCores = 1,
  digits = 3,
  nMean = 50
)

\S4method{getSignificantGenes}{factor}(
  geneSet,
  rankings,
  signifRankingNames = NULL,
  method = "iCisTarget",
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = c("geneList", "incidMatrix"),
  nCores = 1,
  digits = 3,
  nMean = 50
)

\S4method{getSignificantGenes}{GeneSet}(
  geneSet,
  rankings,
  signifRankingNames = NULL,
  method = "iCisTarget",
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = c("geneList", "incidMatrix"),
  nCores = 1,
  digits = 3,
  nMean = 50
)

\S4method{getSignificantGenes}{GeneSetCollection}(
  geneSet,
  rankings,
  signifRankingNames = NULL,
  method = "iCisTarget",
  maxRank = 5000,
  plotCurve = FALSE,
  genesFormat = c("geneList", "incidMatrix"),
  nCores = 1,
  digits = 3,
  nMean = 50
)
}
\arguments{
\item{resultsTable}{[addSignificantGenes]
Output table from \code{\link{addMotifAnnotation}}}

\item{geneSets}{[addSignificantGenes] List of gene-sets which was analyzed.}

\item{rankings}{Motif rankings used to analyze the gene list
(They should be the same as used for calcAUC in this same analysis).}

\item{maxRank}{Maximum rank to take into account for the recovery curve
(Default: 5000).}

\item{plotCurve}{Logical. Wether to plot the recovery curve (Default: FALSE).}

\item{genesFormat}{"geneList" or "incidMatrix". Format to return the genes
(Default: "geneList").}

\item{method}{"iCisTarget" or "aprox". There are two methods to identify the
highly ranked genes:
 (1) equivalent to the ones used in iRegulon and i-cisTarget
 (method="iCisTarget", recommended if running time is not an issue),
 and (2) a faster implementation based on an approximate distribution
 using the average at each rank (method="aprox",
 useful to scan multiple gene sets). (Default: "aprox")}

\item{nMean}{Only used for "aprox" method: Interval to calculate the running
mean and sd. Default: 50 (aprox. nGenesInRanking/400).}

\item{nCores}{Number of cores to use for parallelization (Default: 1).}

\item{geneSet}{[getSignificantGenes] Gene-set to analyze (Only one).}

\item{signifRankingNames}{[getSignificantGenes] Motif ranking name.}

\item{digits}{[getSignificantGenes]
Number of digits to include in the output.}
}
\value{
Output from \code{\link{addMotifAnnotation}}
adding the folowing columns:
\itemize{
  \item nEnrGenes: Number of genes highly ranked
  \item rankAtMax: Ranking at the maximum enrichment,
  used to determine the number of enriched genes.
  \item enrichedGenes: Genes that are highly ranked for the given motif.
  If genesFormat="geneList", the gene names are collapsed into a comma
  separated text field (alphabetical order). If genesFormat="incidMatrix",
  they are formatted as an indicence matrix, i.e. indicanting with 1 the
  genes present, and 0 absent.
}

If plotCurve=TRUE, the recovery curve is plotted.
}
\description{
Identify which genes (of the gene-set) are highly ranked
for each motif.

\itemize{
  \item addSignificantGenes(): adds them to the results table.
  \item getSignificantGenes():
  Calculates the significant genes for ONE gene set.
  It provides the plot and the gene list (it is used by addSignificantGenes).
}
}
\details{
The highly ranked genes are selected based on the distribution of the
recovery curves of the gene set across all the motifs in the database.
In the plot, the red line indicates the average of the recovery curves of
all the motifs, the green line the average + standard deviation, and the
blue line the recovery curve of the current motif.
The point of maximum distance between the current motif and the green curve
(mean+sd), is the rank selected as maximum enrichment.
All the genes with lower rank will be considered enriched.

Depending on whether the method is "iCisTarget" or "aprox", the mean and
SD at each rank are calculated slightly different.
"iCisTarget" method calculates the recovery curves for all the motifs, and
 then calculates the average and SD at each rank.
Due to the implementation of the function in R, this method is slower than
just subsetting the ranks of the genes in for each motif,
and calculating the average of the available ones at each position with a
sliding window.
Since there are over 18k motifs, the chances of getting several measures at
each rank are very high and highly resemble the results calculated
by iCisTarget, though they are often not exactly the same
(hence the name: "aprox" method).
}
\examples{

##################################################
# Setup & previous steps in the workflow:

#### Gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

#### Databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
# motifRankings <- importRankings("hg19-500bp-upstream-7species.mc9nr.feather")

## For this example we will use a SUBSET of the ranking/motif databases:
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9

### Run RcisTarget
# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)
# Step 2. Select significant motifs, add TF annotation & format as table
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
           motifAnnot=motifAnnotation)

##################################################

##################################################
# (This step: Step 3)
# Identify the genes that have the motif significantly enriched
# (i.e. genes from the gene set in the top of the ranking)
par(mfrow=c(1,2))
motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable,
                                       genesFormat="geneList",
                                       plotCurve=TRUE,
                                       geneSets=geneLists,
                                       rankings=motifRankings,
                                       method="aprox")

#### Exploring the output:
# The object returned is a data.table
# Feel free to convert it to a data.frame:
motifEnrichmentTable_wGenes <- as.data.frame(motifEnrichmentTable_wGenes)

# Enriched genes
enrGenes <- motifEnrichmentTable_wGenes[1,"enrichedGenes"]
enrGenes
strsplit(enrGenes, ";")

# As incidence matrix
motifEnr_wIncidMat <- addSignificantGenes(motifEnrichmentTable,
                geneSets=geneLists, rankings=motifRankings,
                method="aprox",
                genesFormat = "incidMatrix")

motifEnr_wIncidMat <- as.data.frame(motifEnr_wIncidMat)
which(colnames(motifEnr_wIncidMat) == "rankAtMax")

incidMat <- motifEnr_wIncidMat[,8:ncol(motifEnr_wIncidMat)]
rownames(incidMat) <- motifEnr_wIncidMat[,"motif"]
incidMat <- incidMat[, colSums(incidMat)>0, drop=FALSE]

# Plot as network
par(mfrow=c(1,1))
library(igraph)
plot(graph.incidence(incidMat))

###############################################################
# Alternative method: getSignificantGenes()
selectedMotif <- rownames(incidMat)
onlyGenes <- getSignificantGenes(geneSet=geneLists$hypoxia,
                            signifRankingNames=selectedMotif,
                            genesFormat="incidMatrix",
                            plotCurve=TRUE,
                            rankings=motifRankings,
                            method="aprox")


}
\seealso{
Previous step in the workflow: \code{\link{addMotifAnnotation}}.

See the package vignette for examples and more details:
\code{vignette("RcisTarget")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_getDbRegionsLoc.R
\name{getDbRegionsLoc}
\alias{getDbRegionsLoc}
\title{Gets the region location for the given database IDs.}
\usage{
getDbRegionsLoc(featherFilePath, spltChr = "__", indexCol = NULL)
}
\arguments{
\item{featherFilePath}{Path to the rankings database}

\item{spltChr}{Character(s) used to split the prefix from the region location.
The default is used for current Drosophila versions. Use NULL to skip.}

\item{indexCol}{Column name including the motif/feature IDs. By default it will use the first column.}
}
\value{
The region locations in a GRanges object, with the original region ID as name.

See the package vignette for examples and more details:
\code{vignette("RcisTarget")}
}
\description{
Gets the region location based on the region ID.
Only needed for drosophila\bold{drosophila} (fruit fly) regions.

For \bold{human/mouse} the region locations are stored in a separate object 
(i.e. \code{}). This function is not needed.
}
\examples{
\dontrun{
featherFilePath <- "~/databases/dm6-regions-11species.mc9nr.feather"
dbRegionsLoc <- getDbRegionsLoc(featherFilePath)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/02_addMotifAnnotation.R
\name{addMotifAnnotation}
\alias{addMotifAnnotation}
\title{Add motif annotation}
\usage{
addMotifAnnotation(
  auc,
  nesThreshold = 3,
  digits = 3,
  motifAnnot = NULL,
  motifAnnot_highConfCat = c("directAnnotation", "inferredBy_Orthology"),
  motifAnnot_lowConfCat = c("inferredBy_MotifSimilarity",
    "inferredBy_MotifSimilarity_n_Orthology"),
  idColumn = "motif",
  highlightTFs = NULL,
  keepAnnotationCategory = TRUE
)
}
\arguments{
\item{auc}{Output from calcAUC.}

\item{nesThreshold}{Numeric. NES threshold to calculate the motif significant
(3.0 by default). The NES is calculated -for each motif- based on the AUC
distribution of all the motifs for the gene-set [(x-mean)/sd].}

\item{digits}{Integer. Number of digits for the AUC and NES in the
output table.}

\item{motifAnnot}{Motif annotation database containing the 
annotations of the motif to transcription factors.
The names should match the ranking column names.}

\item{motifAnnot_highConfCat}{Categories considered as source for 
'high confidence' annotations. By default, 
"directAnnotation" (annotated in the source database), and 
"inferredBy_Orthology" (the motif is annotated to an homologous/ortologous 
gene).}

\item{motifAnnot_lowConfCat}{Categories considered 
'lower confidence' source for annotations. By default, the annotations 
inferred based on motif similarity ("inferredBy_MotifSimilarity", 
"inferredBy_MotifSimilarity_n_Orthology").}

\item{idColumn}{Annotation column containing the ID (e.g. motif, accession)}

\item{highlightTFs}{Character. If a list of transcription factors is
provided, the column TFinDB in the otuput table will indicate whether any
of those TFs are included within the 'high-confidence' annotation 
(two asterisks, **)
or 'low-confidence' annotation (one asterisk, *) of the motif.
The vector can be named to indicate which TF to highlight for each gene-set.
Otherwise, all TFs will be used for all geneSets.}

\item{keepAnnotationCategory}{Include annotation type in the TF information?}
}
\value{
\code{\link[data.table]{data.table}} with the folowing columns:
\itemize{
\item geneSet: Name of the gene set
\item motif: ID of the motif
(colnames of the ranking, it might be other kind of feature)
\item NES: Normalized enrichment score of the motif in the gene-set
\item AUC: Area Under the Curve (used to calculate the NES)
\item TFinDB: Indicates whether the highlightedTFs are included within the
high-confidence annotation (two asterisks, **)
or lower-confidence annotation (one asterisk, *)
\item TF_highConf: Transcription factors annotated to the motif 
based on high-confidence annotations.
\item TF_lowConf: Transcription factors annotated to the motif according to
based on lower-confidence annotations.
}
}
\description{
Select significant motifs and/or annotate motifs to
genes or transcription factors.
The motifs are considered significantly enriched if they pass the the
Normalized Enrichment Score (NES) threshold.
}
\examples{

##################################################
# Setup & previous steps in the workflow:

#### Gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

#### Databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
# motifRankings <- importRankings("hg19-500bp-upstream-7species.mc9nr.feather")

## For this example we will use a SUBSET of the ranking/motif databases:
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9

### Run RcisTarget
# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)

##################################################

### (This step: Step 2)
# Before starting: Setup the paralell computation
library(BiocParallel); register(MulticoreParam(workers = 2)) 
# Select significant motifs, add TF annotation & format as table
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                                           motifAnnot=motifAnnotation)

# Alternative: Modifying some options
motifEnrichment_wIndirect <- addMotifAnnotation(motifs_AUC, nesThreshold=2, 
        motifAnnot=motifAnnotation,
        highlightTFs = "HIF1A", 
        motifAnnot_highConfCat=c("directAnnotation"), 
        motifAnnot_lowConfCat=c("inferredBy_MotifSimilarity",
                                "inferredBy_MotifSimilarity_n_Orthology",
                                "inferredBy_Orthology"),
        digits=3)

# Getting TFs for a given TF:
motifs <- motifEnrichmentTable$motif[1:3]

getMotifAnnotation(motifs, motifAnnot=motifAnnotation)
getMotifAnnotation(motifs, motifAnnot=motifAnnotation, returnFormat="list")

### Exploring the output:
# Number of enriched motifs (Over the given NES threshold)
nrow(motifEnrichmentTable)

# Interactive exploration
motifEnrichmentTable <- addLogo(motifEnrichmentTable)
DT::datatable(motifEnrichmentTable, filter="top", escape=FALSE,
              options=list(pageLength=50))
# Note: If using the fake database, the results of this analysis are meaningless

# The object returned is a data.table (for faster computation),
# which has a diferent syntax from the standard data.frame or matrix
# Feel free to convert it to a data.frame (as.data.frame())
motifEnrichmentTable[,1:6]


##################################################
# Next step (step 3, optional):
\dontrun{
  motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable,
                                                     geneSets=geneLists,
                                                     rankings=motifRankings,
                                                     method="aprox")
}
}
\seealso{
Next step in the workflow: \code{\link{addSignificantGenes}}.

Previous step in the workflow: \code{\link{calcAUC}}.

See the package vignette for examples and more details:
\code{vignette("RcisTarget")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_motifAnnotations.R
\docType{data}
\name{motifAnnotations}
\alias{motifAnnotations}
\alias{motifAnnotations_hgnc}
\alias{motifAnnotations_mgi}
\alias{motifAnnotations_dmel}
\alias{motifAnnotations_hgnc_v9}
\alias{motifAnnotations_mgi_v9}
\alias{motifAnnotations_dmel_v9}
\alias{motifAnnotations_hgnc_v8}
\alias{motifAnnotations_mgi_v8}
\alias{motifAnnotations_dmel_v8}
\title{Annotations of Motifs to TFs}
\description{
\itemize{
\item{\bold{motifAnnotations_hgnc}: }{Annotations to \bold{HUMAN} transcription factors for 
  the rankings using motif collection version 10.
  Source: \emph{motifs-v10nr_clust-nr.hgnc-m0.001-o0.0.tbl}}
 
\item{\bold{motifAnnotations_mgi}: }{Contains the annotations to \bold{MOUSE} transcription factors for 
the rankings using motif collection version 10.
Source: \emph{motifs-v10nr_clust-nr.mgi-m0.001-o0.0.tbl}}

\item{\bold{motifAnnotations_dmel}: }{Contains the annotations to \bold{FLY} transcription factors for 
the rankings using motif collection version 10.
Source: \emph{motifs-v10nr_clust-nr.flybase-m0.001-o0.0.tbl}}
}
\bold{Previous versions}: 

Annotations for motif collection version 9 ('mc9nr').
\itemize{
    \item{Human: motifAnnotations_hgnc_v9 (\emph{motifs-v9-nr.hgnc-m0.001-o0.0.tbl}})
    \item{Mouse: motifAnnotations_mgi_v9 (\emph{motifs-v9-nr.mgi-m0.001-o0.0.tbl}})
    \item{Fly: motifAnnotations_dmel_v9 (\emph{motifs-v9-nr.flybase-m0.001-o0.0.tbl}})
    }
    
Annotations for motif collection version 8 ('mc8nr'). 
- Deprecated: Will be removed in upcoming versions of the package
\itemize{
    \item{Human: motifAnnotations_hgnc_v8 (\emph{motifs-v8-nr.hgnc-m0.001-o0.0.tbl}})
    \item{Mouse: motifAnnotations_mgi_v8 (\emph{motifs-v8-nr.mgi-m0.001-o0.0.tbl}})
    \item{Fly: motifAnnotations_dmel_v8 (\emph{motifs-v8-nr.flybase-m0.001-o0.0.tbl}})
    }


These objects are meant to be provided to RcisTarget without modification, 
but it can also be explored by the user 
to obtain further information about the motifs.
The original files can be downloaded from \code{https://resources.aertslab.org/cistarget/motif2tf/}
Columns:
\itemize{
 \item{\bold{motif}: }{Motif ID.}
 \item{\bold{TF}: }{Transcription factor (or inferred gene).}
 \item{\bold{directAnnotation}, \bold{inferred_Orthology}, 
       \bold{inferred_MotifSimil}: }
    {Boolean values indicating whether the motif is 
       annotated to the TF in the source database ("directAnnotation"), 
       or whether it was inferred by orthology ("inferred_Orthology") 
       or motif similarity ("inferred_MotifSimil").}
 \item{\bold{Description}: }{Description of the source of the annotation.}
   \item{\bold{annotationSource}: }{
     Source of the annotation formatted as factor (e.g. for subsetting). 
     Levels: directAnnotation, inferredBy_Orthology, 
     inferredBy_MotifSimilarity, inferredBy_MotifSimilarity_n_Orthology.}
}
}
\details{
Documentation for the data
}
\seealso{
importAnnotations, RcisTarget
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_addLogo.R
\name{showLogo}
\alias{showLogo}
\title{Show RcisTarget as HTML}
\usage{
showLogo(
  motifEnrDT,
  motifCol = c("motif", "bestMotif", "MotifID"),
  dbVersion = NULL,
  nSignif = 3,
  colsToShow = c(motifEnrichment = c("motifDb", "logo", "NES", "geneSet", "TF_highConf"),
    regulonTargets = c("TF", "gene", "nMotifs", "bestMotif", "logo", "NES",
    "highConfAnnot", "Genie3Weight")),
  options = list(pageLength = 50),
  ...
)
}
\arguments{
\item{motifEnrDT}{Results from RcisTarget (data.table)}

\item{motifCol}{Name of the column which contains the logo ID.}

\item{dbVersion}{For current databases (version 10) use "v10nr_clust"}

\item{nSignif}{Number of digits to show in numeric columns.}

\item{colsToShow}{Columns to show in the HTML 
(by default, the list of the enriched genes is hidden)}

\item{options}{List of options to pass to \code{DT::databable}}

\item{...}{Other arguments to pass to \code{DT::databable}}
}
\value{
Returns the DT::datatable() object which can be shown as HTML.
}
\description{
Shows the results motif enrichment table as an HTML 
including the motif logos. Note that Transfac-Pro logos cannot be shown.
}
\examples{
# Run the enrichment (or load previous results)
load(paste(file.path(system.file('examples', package='RcisTarget')),
           "motifEnrichmentTable_wGenes.RData", sep="/"))

# Show table as HTML
showLogo(motifEnrichmentTable_wGenes)
}
\seealso{
See the package vignette for more examples:
\code{vignette("RcisTarget")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_addLogo.R
\name{addLogo}
\alias{addLogo}
\title{Add motif logo to RcisTarget results table}
\usage{
addLogo(motifEnrDT, addHTML = TRUE, dbVersion = NULL, motifCol = "motif")
}
\arguments{
\item{motifEnrDT}{Results from RcisTarget (data.table)}

\item{addHTML}{Whether to add the HTML tag <img> around the URL or not
(boolean).}

\item{dbVersion}{The default value 'v10nr_clust' corresponds to the 
latest version of the databases (currently version 10). 
For previous databases use 'v8' or 'v9', as appropriate.}

\item{motifCol}{Name of the column which contains the logo ID.}
}
\value{
Returns the results table with a new column: 'logo'.
This column contains either a URL with the logo image, or the HTML code to
show the logo [e.g. with datatable()].
}
\description{
Adds a column containing the logo URL to RcisTarget results
table.
}
\examples{
# Run the enrichment (or load previous results)
load(paste(file.path(system.file('examples', package='RcisTarget')),
           "motifEnrichmentTable_wGenes.RData", sep="/"))

# Add link to logo
newMotifErnTable <- addLogo(motifEnrichmentTable_wGenes)

# Show table
library(DT)
datatable(newMotifErnTable[,-c("enrichedGenes"), with=FALSE],
          escape = FALSE,
          filter="top",
          options=list(pageLength=5))

}
\seealso{
\code{vignette("showLogo")} to directly show the table as HTML. 
See the package vignette for more examples:
\code{vignette("RcisTarget")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/02_addMotifAnnotation.R
\name{getMotifAnnotation}
\alias{getMotifAnnotation}
\title{Get motif annotation}
\usage{
getMotifAnnotation(
  motifs,
  motifAnnot,
  annotCats = c("directAnnotation", "inferredBy_MotifSimilarity", "inferredBy_Orthology",
    "inferredBy_MotifSimilarity_n_Orthology"),
  idColumn = "motif",
  returnFormat = c("asCharacter", "subset", "list")[1],
  keepAnnotationCategory = TRUE
)
}
\arguments{
\item{motifs}{Motif IDs}

\item{motifAnnot}{Motif annotation database containing the 
annotations of the motif to genes or transcription factors.}

\item{annotCats}{Annotation categories to be considered:
"directAnnotation" (annotated in the source database),  
"inferredBy_Orthology" (the motif is annotated to an homologous/ortologous 
gene), or inferred based on motif similarity ("inferredBy_MotifSimilarity", 
"inferredBy_MotifSimilarity_n_Orthology").}

\item{idColumn}{Annotation column containing the ID (e.g. motif, accession)}

\item{returnFormat}{Determines the output format. Choose one of the following values:}

\item{keepAnnotationCategory}{Include annotation type in the TF information?
\itemize{
\item \code{asCharacter}: Named vector with the genes or TFs annotated to the given motifs (in the same order, including empty and duplicated values).
\item \code{subset}: Subset of the annotation table (list split by motif)
\item \code{list}: List of TF names (unique values), duplicated motifs or motifs without annotation are not returned.
}}
}
\value{
See argument \code{returnFormat}
}
\description{
Get the genes/transcription factors annotated to the given motifs
}
\examples{

##################################################
# Setup & previous steps in the workflow:

#### Gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

#### Databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
# motifRankings <- importRankings("hg19-500bp-upstream-7species.mc9nr.feather")

## For this example we will use a SUBSET of the ranking/motif databases:
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9

### Run RcisTarget
# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)

##################################################

### (This step: Step 2)
# Before starting: Setup the paralell computation
library(BiocParallel); register(MulticoreParam(workers = 2)) 
# Select significant motifs, add TF annotation & format as table
motifEnrichmentTable <- addMotifAnnotation(motifs_AUC,
                                           motifAnnot=motifAnnotation)

# Alternative: Modifying some options
motifEnrichment_wIndirect <- addMotifAnnotation(motifs_AUC, nesThreshold=2, 
        motifAnnot=motifAnnotation,
        highlightTFs = "HIF1A", 
        motifAnnot_highConfCat=c("directAnnotation"), 
        motifAnnot_lowConfCat=c("inferredBy_MotifSimilarity",
                                "inferredBy_MotifSimilarity_n_Orthology",
                                "inferredBy_Orthology"),
        digits=3)

# Getting TFs for a given TF:
motifs <- motifEnrichmentTable$motif[1:3]

getMotifAnnotation(motifs, motifAnnot=motifAnnotation)
getMotifAnnotation(motifs, motifAnnot=motifAnnotation, returnFormat="list")

### Exploring the output:
# Number of enriched motifs (Over the given NES threshold)
nrow(motifEnrichmentTable)

# Interactive exploration
motifEnrichmentTable <- addLogo(motifEnrichmentTable)
DT::datatable(motifEnrichmentTable, filter="top", escape=FALSE,
              options=list(pageLength=50))
# Note: If using the fake database, the results of this analysis are meaningless

# The object returned is a data.table (for faster computation),
# which has a diferent syntax from the standard data.frame or matrix
# Feel free to convert it to a data.frame (as.data.frame())
motifEnrichmentTable[,1:6]


##################################################
# Next step (step 3, optional):
\dontrun{
  motifEnrichmentTable_wGenes <- addSignificantGenes(motifEnrichmentTable,
                                                     geneSets=geneLists,
                                                     rankings=motifRankings,
                                                     method="aprox")
}
}
\seealso{
\code{\link{addMotifAnnotation}} add the annotation directly to the motif enrichment results.

See the package vignette for examples and more details:
\code{vignette("RcisTarget")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/10_cisTarget.R
\name{cisTarget}
\alias{cisTarget}
\title{cisTarget}
\usage{
cisTarget(
  geneSets,
  motifRankings,
  motifAnnot = NULL,
  motifAnnot_highConfCat = c("directAnnotation", "inferredBy_Orthology"),
  motifAnnot_lowConfCat = c("inferredBy_MotifSimilarity",
    "inferredBy_MotifSimilarity_n_Orthology"),
  highlightTFs = NULL,
  nesThreshold = 3,
  aucMaxRank = 0.05 * ncol(motifRankings),
  geneErnMethod = "aprox",
  geneErnMaxRank = 5000,
  nCores = 1,
  verbose = TRUE
)
}
\arguments{
\item{geneSets}{List of gene-sets to analyze.
The gene-sets should be provided as \code{\link{GeneSet}},
\code{\link{GeneSetCollection}} or character list (see examples).}

\item{motifRankings}{Database of the appropiate organism and search-space
(i.e. 10kbp around- or 500bp upstream the TSS).
These objects are provided in separate files, 
which can be imported with \code{importRankings()}:
\itemize{
\item \url{http://pyscenic.aertslab.org/databases/mm9-500bp-upstream-7species.mc9nr.feather}[mm9-500bp-upstream-7species.mc9nr] (Mouse, 500bp)
\item \url{http://pyscenic.aertslab.org/databases/mm9-tss-centered-10kb-7species.mc9nr.feather}[mm9-tss-centered-10kb-7species.mc9nr] (Mouse, 10kbp)
\item \url{http://pyscenic.aertslab.org/databases/hg19-500bp-upstream-7species.mc9nr.feather}[hg19-500bp-upstream-7species.mc9nr] (Human, 500bp)
\item \url{http://pyscenic.aertslab.org/databases/hg19-tss-centered-10kb-7species.mc9nr.feather}[hg19-tss-centered-10kb-7species.mc9nr] (Human, 10kbp)
\item -Coming soon- (Fly)
}
See \code{vignette("RcisTarget")} for an exhaustive list of databases.}

\item{motifAnnot}{Motif annotation database containing the
annotations of the motif to transcription factors.}

\item{motifAnnot_highConfCat}{Categories considered as source for 
'high confidence' annotations. By default, 
"directAnnotation" (annotated in the source database), and 
"inferredBy_Orthology" (the motif is annotated to an homologous/ortologous 
gene).}

\item{motifAnnot_lowConfCat}{Categories considered 
'lower confidence' source for annotations. By default, the annotations 
inferred based on motif similarity ("inferredBy_MotifSimilarity", 
"inferredBy_MotifSimilarity_n_Orthology").}

\item{highlightTFs}{Character. 
If a list of transcription factors is
provided, the column TFinDB in the otuput table will indicate whether any
of those TFs are included within the 'high-confidence' annotation 
(two asterisks, **)
or 'low-confidence' annotation (one asterisk, *) of the motif.
The vector can be named to indicate which TF to highlight for each gene-set.
Otherwise, all TFs will be used for all geneSets.}

\item{nesThreshold}{Numeric.
NES threshold to calculate the motif significant (3.0 by default).
The NES is calculated -for each motif- based on the AUC distribution of
all the motifs for the gene-set [(x-mean)/sd].
The motifs are considered significantly enriched if they pass the the
 Normalized Enrichment Score (NES) threshold.}

\item{aucMaxRank}{Threshold to calculate the AUC.
In a simplified way, the AUC value represents the fraction of genes -within
 the top X genes in the ranking- that are included in the signature.
The parameter 'aucThresholdPERC' allows to modify the percentage of genes
(of the top of the ranking) that is used to perform this computation.
By default it is set to 5\% of the total number of genes in the rankings.
Common values range from 1 to 10\%.}

\item{geneErnMethod}{"iCisTarget" or "aprox". Method to identify the highly
ranked genes (see \link{addSignificantGenes} for details).}

\item{geneErnMaxRank}{Maximum rank to take into account for the gene
enrichment recovery curve (see \link{addSignificantGenes} for details).}

\item{nCores}{Number of cores to use for computation.
Note: In general, using a higher number of cores (e.g. processes) decreases
overall running time. However, it also deppends on the available memory and
overall system load. Setting nCores too high might also decrease performance.}

\item{verbose}{Should the function show progress messages? (TRUE / FALSE)}
}
\value{
\code{\link[data.table]{data.table}} containing the over-represented
motifs (according to the selected NES threshold),
their statistics, annotation to transcription factors and the genes with
high enrichment of the motif.
}
\description{
Identifies DNA motifs significantly over-represented in a
gene-set.

This is the main function to run RcisTarget.
It includes on the following steps:
\itemize{
\item 1. Motif enrichment analysis (\link{calcAUC})
\item 2. Motif-TF annotation (\link{addMotifAnnotation})
\item 3. Selection of significant genes (\link{addSignificantGenes})
}
}
\examples{


# Example for running RcisTarget using cisTarget() function (workflow wrapper)

\dontrun{

##################################################
### Load your gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

### Load databases
# Motif rankings: Select according to organism and distance around TSS
# (See the vignette for URLs to download)
motifRankings <- importRankings("hg19-500bp-upstream-7species.mc9nr.feather")

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9
##################################################

# Run (R)cisTarget
motifEnrichmentTable_wGenes <- cisTarget(geneLists, motifRankings,
  motifAnnot_direct=hg19_direct_motifAnnotation,
  nesThreshold=3.5, geneErnMethod="aprox", nCores=2)

}

# Load results from analysis
load(paste(file.path(system.file('examples', package='RcisTarget')),
           "motifEnrichmentTable_wGenes.RData", sep="/"))


### Exploring the output:
# Note: If using the fake-database, the results are not meaningful

# Number of enriched motifs (Over the given NES threshold)
nrow(motifEnrichmentTable_wGenes)

# Available info (columns)
colnames(motifEnrichmentTable_wGenes)

# The object returned is a data.table (for faster computation),
# which has a diferent syntax from the standard data.frame or matrix
# Feel free to convert it to a data.frame (as.data.frame())
class(motifEnrichmentTable_wGenes)
motifEnrichmentTable_wGenes[,1:5]

# Enriched genes
enrGenes <- as.character(motifEnrichmentTable_wGenes[1,"enrichedGenes"])
strsplit(enrGenes, ";")


# Interactive exploration
motifEnrichmentTable_wGenes <- addLogo(motifEnrichmentTable_wGenes)
DT::datatable(motifEnrichmentTable_wGenes[,1:9], escape = FALSE, filter="top",
              options=list(pageLength=5))
# Note: If using the fake database, the results of this analysis are meaningless

}
\seealso{
See the package vignette for examples and more details:
\code{vignette("RcisTarget")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_reRank.R
\name{reRank}
\alias{reRank}
\title{Re-rank RcisTarget ranking}
\usage{
reRank(rankingsDb, columns = NULL)
}
\arguments{
\item{rankingsDb}{Results from RcisTarget (data.table)}

\item{columns}{Whether to add the HTML tag <img> around the URL or not
(boolean).}
}
\value{
Returns a new ranking database with the new ranking values.
}
\description{
Re-ranks the genes/regions in the database for each motif. This allows to do motif enrichment over a background.
}
\examples{

library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly


genes <- colnames(getRanking(motifRankings))[10:20]
reRank(motifRankings, columns=genes)
}
\seealso{
See the "background" vignette for more examples:
\code{vignette("RcisTarget-withBackground")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class_rankingRcisTarget.R
\docType{class}
\name{rankingRcisTarget-class}
\alias{rankingRcisTarget-class}
\alias{rankingRcisTarget}
\alias{show,rankingRcisTarget-method}
\alias{getRanking}
\alias{getRanking,rankingRcisTarget-method}
\alias{nrow,rankingRcisTarget-method}
\alias{ncol,rankingRcisTarget-method}
\alias{colnames,rankingRcisTarget-method}
\alias{rownames,rankingRcisTarget-method}
\alias{getMaxRank}
\alias{getMaxRank,rankingRcisTarget-method}
\alias{getNumColsInDB}
\alias{getNumColsInDB,rankingRcisTarget-method}
\title{Class to store the motif databases for RcisTarget.}
\usage{
\S4method{show}{rankingRcisTarget}(object)

\S4method{getRanking}{rankingRcisTarget}(object)

\S4method{nrow}{rankingRcisTarget}(x)

\S4method{ncol}{rankingRcisTarget}(x)

\S4method{colnames}{rankingRcisTarget}(x)

\S4method{rownames}{rankingRcisTarget}(x)

\S4method{getMaxRank}{rankingRcisTarget}(x)

\S4method{getNumColsInDB}{rankingRcisTarget}(x)
}
\arguments{
\item{object}{[method: show] rankingRcisTarget object to show}

\item{x}{[several methods] rankingRcisTarget object to apply the method}
}
\value{
\itemize{
\item show: Prints a summary of the object
\item getRanking: Returns the rankings
\item ncol, nrow: Returns the number of columns or rows of the ranking
}
}
\description{
This class contains the rankings used by RcisTarget. 

They are typically loaded from a .feather file with \code{importRankings()}.

If the associated .descr file is available, 
it will also load the description of the database.

Class slots:

\itemize{
\item rankings: data.frame (tbl_df) containing the rankings
\item colType: 'gene'or 'region'
\item rowType: 'motif' or the type of feature is stored (e.g. ChipSeq)
\item org: human/mouse/fly
\item genome: hg19, mm9, ...
\item nColsInDB: Number of columns (e.g. genes/regions) available 
in the database (.feather file). 
Note that not all might be loaded in the current object.
\item description: global description, summary, or any other information
\item maxRank: Maximum ranking included in the database, 
higher values are converted to Inf.
}

Note that the main slot is \code{@rankings}, 
which is the one used by RcisTarget 
(it can accessed with \code{getRanking()}).
The 'description' slots are mostly for user convenience.
}
\examples{
## Loading from a .feather file:
# dbFile <- "hg19-500bp-upstream-7species.mc9nr.feather"
# motifRankings <- importRankings(dbFile)
# motifRankings

## Loading a built object:
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data("hg19_500bpUpstream_motifRanking_cispbOnly")
hg19_500bpUpstream_motifRanking_cispbOnly
class(hg19_500bpUpstream_motifRanking_cispbOnly)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00_importAnnotations.R
\name{importAnnotations}
\alias{importAnnotations}
\title{Imports the annotations of motifs to transcription factors}
\usage{
importAnnotations(annotFile, motifsInRanking = NULL, columnsToKeep = NULL)
}
\arguments{
\item{annotFile}{File containing the motif annotations corresponding to the
rankings. They should match in organism and version.}

\item{motifsInRanking}{Subset of motifs to keep.
e.g. 
\code{motifsInRanking=getRanking(motifRankings)$features}}

\item{columnsToKeep}{Other colums from the file to keep}
}
\value{
data.table with the annotations of the motifs to transcription factors

Columns:
 \itemize{
   \item{\bold{motif}: }{Motif ID.}
   \item{\bold{TF}: }{Transcription factor (or inferred gene).}
   \item{\bold{directAnnotation}, \bold{inferred_Orthology}, 
     \bold{inferred_MotifSimil}: }{
       Boolean values indicating whether the motif is 
       annotated to the TF in the source database ("directAnnotation"), 
       or whether it was inferred by orthology ("inferred_Orthology") 
       or motif similarity ("inferred_MotifSimil").}
   \item{\bold{Description}: }{Description of the source of the annotation.}
   \item{\bold{annotationSource}: }{Source of the annotation 
     formatted as factor (e.g. for subsetting). 
     Levels: directAnnotation, inferredBy_Orthology, 
     inferredBy_MotifSimilarity, inferredBy_MotifSimilarity_n_Orthology.}
 }
}
\description{
RcisTarget package includes the motif annotations for the rankings 
using the latest motif collection (version 10 clustered, 19895 motifs): 

\itemize{
\item{Human: }{ \code{data(motifAnnotations_hgnc)}}
\item{Mouse: }{ \code{data(motifAnnotations_mgi)}}
\item{Fly: }{ \code{data(motifAnnotations_dmel)}}

\item{Previous versions (Annotations for motif collection version 9 (24453 motifs) or 8:}{
motifAnnotations_hgnc_v9 (Human), motifAnnotations_mgi_v9 (Mouse), motifAnnotations_dmel_v9 (Fly)
motifAnnotations_hgnc_v8 (Human), motifAnnotations_mgi_v8 (Mouse), motifAnnotations_dmel_v8 (Fly)
}
}

This function (importAnnotations) allows to import annotations 
for other versions of the rankings, or to keep extra data columns.

e.g. Source of the annotations: \code{https://resources.aertslab.org/cistarget/motif2tf/}
}
\examples{
# motifAnnotations <- importAnnotations("motifs-v10nr_clust-nr.hgnc-m0.001-o0.0.tbl")

## To save (decrease from ~100MB to 1MB): 
# save(motifAnnotations, file="motifAnnotations_hngc.RData", compress='xz')

# This code would generate the equivalent to
data(motifAnnotations_hgnc)
}
\seealso{
See \emph{iRegulon} paper and documentation for \bold{details} on how the
rankings and annotations were built.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class_aucScores.R
\docType{class}
\name{aucScores-class}
\alias{aucScores-class}
\alias{aucScores}
\alias{getAUC}
\alias{show,aucScores-method}
\alias{getAUC,aucScores-method}
\title{Class to store the AUC scores for RcisTarget.}
\usage{
\S4method{show}{aucScores}(object)

\S4method{getAUC}{aucScores}(object)
}
\arguments{
\item{object}{Results from \code{calcAUC}.}
}
\value{
\itemize{
\item show: Prints a summary of the object
\item getAUC: Returns the matrix containing the AUC scores
}
}
\description{
Contains the AUC scores for each gene- or region-set.
They can be accessed through \code{getAUC()} and the regular methods
(i.e. nrow, rownames... ) available for SummarizedExperiment objects.
}
\examples{
##################################################
# Setup & previous steps in the workflow:

#### Gene sets
# As example, the package includes an Hypoxia gene set:
txtFile <- paste(file.path(system.file('examples', package='RcisTarget')),
                 "hypoxiaGeneSet.txt", sep="/")
geneLists <- list(hypoxia=read.table(txtFile, stringsAsFactors=FALSE)[,1])

#### Databases
## Motif rankings: Select according to organism and distance around TSS
## (See the vignette for URLs to download)
# motifRankings <- importRankings("hg19-500bp-upstream-7species.mc9nr.feather")

## For this example we will use a SUBSET of the ranking/motif databases:
library(RcisTarget.hg19.motifDBs.cisbpOnly.500bp)
data(hg19_500bpUpstream_motifRanking_cispbOnly)
motifRankings <- hg19_500bpUpstream_motifRanking_cispbOnly

## Motif - TF annotation:
data(motifAnnotations_hgnc_v9) # human TFs (for motif collection 9)
motifAnnotation <- motifAnnotations_hgnc_v9

### Run RcisTarget
# Step 1. Calculate AUC
motifs_AUC <- calcAUC(geneLists, motifRankings)

##################################################

#Exploring the output:
motifs_AUC

class(motifs_AUC)

# Extracting the AUC matrix:
getAUC(motifs_AUC)[,1:5]

# Subsetting and regular manipulation methods are also available:
motifs_AUC[1,]
motifs_AUC[,3:4]

dim(motifs_AUC)
nrow(motifs_AUC)
ncol(motifs_AUC)
colnames(motifs_AUC)
rownames(motifs_AUC)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00_importRankings.R
\name{importRankings}
\alias{importRankings}
\alias{getRowNames}
\alias{getColumnNames}
\title{Import the motif databases for RcisTarget.}
\usage{
importRankings(
  dbFile,
  indexCol = NULL,
  colType = "gene",
  columns = NULL,
  warnMissingColumns = TRUE,
  dbDescr = NULL
)

getRowNames(dbFile, indexCol = NULL)

getColumnNames(dbFile)
}
\arguments{
\item{dbFile}{.feather or .parquet file containing the rankings}

\item{indexCol}{Column name containing the feature IDs (e.g. motif names or chip-seq tracks). If NULL, it will try to use 'motifs', 'tracks', or 'features'.}

\item{colType}{Colum type. i.e.:'gene'or 'region'}

\item{columns}{Columns to load from the .feather or .parquet file
(e.g. to read only specific genes or regions)}

\item{warnMissingColumns}{If 'columns' is provided, warn if any ID is not available in the rankings?}

\item{dbDescr}{Description fields (not used in the analysis, just for convenience of the user) 
e.g.:
\code{dbDescr=list(colType="gene", rowType="motif",
org="Human", genome="hg19", maxRank=Inf, description="")}}
}
\value{
rankingRcisTarget object with the following slots:
#' \itemize{
\item rankings: data.frame containing the rankings
\item colType: 'gene'or 'region'
\item nColsInDB: Number of columns (e.g. genes/regions) available
in the database (.feather or .parquet file).
Note that not all might be loaded in the current object.
\item rowType: 'motif' or the type of feature is stored (e.g. ChipSeq)
\item org: human/mouse/fly
\item genome: hg19, mm9, ...
\item description: global description, summary, or any other information
\item maxRank: Maximum ranking included in the database,
higher values are converted to Inf.
}
}
\description{
The rankings are typically loaded from a .feather or .parquet file
with \code{importRankings()}.
}
\examples{
## Loading from a .feather or .parquet file:
# dbFilePath = "hg38_10kbp_up_10kbp_down_full_tx_v10_clust.genes_vs_motifs.rankings.feather"
# motifRankings<-importRankings(dbFilePath)

## The annotations for Motif collection 9 (sufix 'mc9nr')
# are included in RcisTarget, and can be loaded with:
data(motifAnnotations_hgnc)

## For other versions, import the appropiate annotation. e.g.:
# annotDb <- importAnnotations("motifs-v10nr_clust-nr.hgnc-m0.001-o0.0.tbl")
# optional: motifsInRanking <- getRanking(motifRankings)$motifs
}
